<title>Resin Change Log</title>

<section title='2.0 snap - Nov 12, 2001'>
<ul>
<li>apache2 mod_caucho needed updating for new structures (rep by Daniel Wroblewski)
<li>(2001-11-14) XmlPrinter.prefixList wasn't checked for null (rep by Michele)
<li>pooled connection fatalException was calling close() twice (rep by Jason Van Cleve)
<li>(2001-11-12) nsapi wasn't detecting resin.conf changes (rep by Jack Yang)
<li>bin/resin should use initgroups (fixed! by Philip Molter)
<li>bin/resin needs nativeFlush to handle flushBuffer (rep by Philip Molter)
<li>changed server.c SIGSEGV handler to use the default (rep by Philip Molter)
<li>new webapps properly initialized after expansion (rep by Will Jaynes)
<li>(2001-11-06) Added XSL TemplatesHandler and TransformerHandler (rep by Christian Sell)
<li>ForbidHost belongs in com.caucho.http.security
<li>RotateStream setRolloverSize was setting wrong value (fixed! by Fredrik Rodland)
<li>(2001-11-05) self::text() was printing as text() (rep by Richard Vowles)
<li>XPath last() wasn't properly using axis (rep by Richard Vowles)
<li>Fixed priorities in &lt;host> regexp (rep by Glen Marchesani)
<li>mod_caucho wasn't understanding jsessionid; when using SetHandler (rep by Jamie Coppedge)
<li>&lt;script> text wasn't handling &lt;/h4> properly (rep by Chris Graham)
<li>javax.servlet.ServletContextAttributesListener wasn't deleted (rep by Anders Eriksson)
<li>added JNDI initialization for javax.mail.Session (rep by jelmer)
<li>race condition in cache of FileServer (found! by G. Nagarajan)
<li>(2001-11-02) added reuse-session-id (default true) to allow disable session-id reuse (rep by Brigger Patrick)
<li>nsapi.c should return error_page on connection failure if possible (fixed! by Jose Manuel Cantera Fonseca)
<li>AbstractTransformerFactory.getFeature needs to return values for StreamSource. (rep by Christian Sell)
<li>JavaScript "with" function scope was using global scope (rep by Stanislav Devyatovskiy)
<li>Possible WriteStream offset bug (rep by Jens Goring)
<li>(2001-10-31) jsp-file with different init-param weren't distinguished (rep by Dmitry Platonoff)
<li>JSP pages with "extends" weren't properly updated (fixed! by Daniel Dadush)
<li>bin/resin fixes for Content-Type and Date (rep by Dmitry Platonoff)
<li>Allow nested tag NESTED variables (rep by Steve Hoffman)
<li>(2001-10-30) removed aggressive DynamicClassLoader.unload
<li>ClassLoader cleanup to ensure proper Class.forName called
<li>WriteStream.print(int i) could have an off-by-one array exception (rep by Jens Goring)
<li>added PasswordDigest to AbstractAuthenticator (rep by Bob Baker)
<li>allow loadClass to be called from non-top (rep by George Moschovitis)
<li>if enable-cookies='false' and given cookie, then need to enable url rewriting (rep by Sudheer Vangati)
<li>(2001-10-29) upgraded config.guess and config.sub
<li>expires and last-modified needs to go back to servlet when expires (rep by Tauren Mills)
<li>mod_caucho needs to save write_length when retrying connection (rep by Mica Cooper)
<li>reuse JNDI factory if have several jndi-link (rep by Sara Chieco)
<li>form error page needs to use "GET" (rep by Sean Rohead)
<li>servlet exception line wrapping shouldn't happen with lines starting with space
<li>rtexprvalue = false was still allowing rtexprs (rep by Martin Nieschke)
<li>(2001-10-25) Response.finish with forward() needs to skip input stream (rep by Song Qiu)
<li>res.getCharacterEncoding should not normalize the encoding (rep by Sebastian Kanthak)
<li>bin/httpd on Win32 broke -install and argument order (rep by Osma Ahvenlampi)
<li>Separated WebDAV AbstractPath for custom webdav sources.
<li>(2001-10-25) getNamedDispatcher must not allocate filters (rep by Sean Rohead)
<li>MultipartForm output stream os.close() must be in finally (rep by George Moschovitis)
<li>QDocument.getElementsByTagName wasn't returning root element (rep by Rodica Balasa)
<li>WebDavServlet allows 'user' as an init-param
<li>JdbcAuthenticator now has cookie-logout option (rep by Eric Carlson)
<li>mod_caucho needs to understand difference between server defaults and &lt;host id=''> (rep by Frank Nestel)
<li>windows line numbers (rep by Erez Holzman)
<li>(2001-10-23) Separated sessions into com.caucho.http.session.
<li>QAbstractNode.getChildNodes() needs to return an empty node list (rep by Alex Besogonov)
<li>Added server-name support in &lt;host> 
<li>access log %{Set-Cookie}o wasn't properly handled (rep by Kirk Rasmussen)
<li>sessions outside the group need a new session id (rep by Mica Cooper)
<li>Added separate StartThread to TcpServer and created threadAcceptMax (rep by Dave King)
<li>Added SingleThreadWrapperPage (rep by Mats Lofkvist)
<li>Added %T %{%H:%M:%S}t and fixed %{cookie}c (rep by Kirk Rasmussen)
</ul>
</section>

<section title='2.0.3 - Oct 17, 2001'>
<ul>
<li>(2001-10-16) JspWriter.UNBOUNDED_BUFFER is final (rep by Steph)
<li>srun-group for tcp-ring and load-balancing understands (rep by Christopher Lynch and Mica Cooper)
<li>WebDAV Destination header wasn't properly decoded (fixed! by Andrey Akselrod)
<li>WebDAV COPY and MOVE circularity check was overzealous (rep by Andrey Akselrod)
<li>Added TcpServerAdmin and server-listener for clean shutdowns (rep by Christopher Lynch and Mica Cooper)
<li>(2001-10-11) war-dir and war-expand-dir need to allow $host-dir (rep by Frank Nestel)
<li>Added shutdown-wait-time (rep by Christopher Lynch)
<li>JSP are now loaded in a single classloader to reduce memory consumption
<li>taglib was overzealously escaping (rep by Jim Fox)
<li>Initial cut of digest authentication (rep by Mark Davidson)
<li>(2001-10-10) Found some cases where TempBuffer wasn't getting freed, causing the GC to work harder.
<li>HTTPS on check needs to be case insensitive (rep by Ralph Schaer)
<li>fixed Apache SEGV for errors in resin.conf parsed by mod_caucho (rep by Steve)
<li>(2001-10-08) On redirect, assume port 443 is https (rep by Ralph Schaer)
<li>jsp:include must use servletPath (rep by Srujana Cherukuri)
<li>DBPool.getPool should store stuff in the ClassLoaderLocal (rep by Cytown)
<li>DBPool wasn't closing connection when receiving connectionError (rep by Cytown)
<li>Added preliminary velocity-style JSP syntax
<li>(2001-10-05) Session store needs to happen before flush (rep by Jon Bodner)
<li>persistent session store must load all on startup (rep by Steve Holt)
<li>add ForbidHost 
<li>persistent session store now has srun-index-specific subdirectories.
<li>moved persistent session store into WEB-INF
<li>sendRedirect shouldn't clear headers (rep by David Rice)
<li>access-log period of 1M should rollover at month end
<li>jsp:directive.page must handle namespace decl (rep by Lukasz Kowalczyk)
<li>transport-guarantee=NONE wasn't understood (rep by Martin Cordova)
<li>(2001-10-02) SingleThreadModel fix for servlets (rep by Mats Lofkvist)
<li>basic WebDAV support
<li>filter.init() must throw ServletException (rep by Ralph Schaer)
<li>(2001-09-28) Added -http-port and -srun-port back to ResinServer (rep by Hiroshi Morita)
<li>static JSP page should have sessions (rep by Alex Greif)
<li>added AccessLog.getArchiveName to allow subclassing  (rep by Mark Saarinen)
<li>added archive-format to the access-log (rep by Mark Saarinen)
<li>JSP setProperty and tag properties must allow PropertyEditors
<li>getF_oo corresponds to property f_oo, not F_oo (rep by Dave Wallace)
<li>LogStream should use getPath("href", null) to allow system properties (fixed! by Andrej Gabara)
<li>Fixed regression failure for chained XSL request (rep by Laurent Tettoni)
<li>NT install needs to strip quotes from paths, e.g. CLASSPATH (rep by Alin Andea)
<li>mod_caucho must be before [7] (header parser) so mod_gzip will work (rep by Aurelien Pelletier)
<li>rotating logs (e.g. stdout-log) now allow a customized timestamp (rep by Jan Aleman)
<li>Added com.caucho.admin.http.ServerAdmin (req by Derek Fisher)
<li>Throw more informative exception when getPage called after application shutdown (rep by Michal Mosiewicz)
<li>cleaned up ClassLoader.getSourcePath (rep by Steve Nicholai)
<li>DBPool should auto-detect ConnectionPoolDataSource for driver-name (rep by Chris Donnelly)
<li>JavaScript generated *.java and *.class belong in WEB-INF/work (rep by Hiroshi Morita)
<li>(2001-09-25) HttpServletResponseWrapper.encodeRedirectURL was circular (rep by Joe Walnes)
<li>getReader() wasn't allowed inside a jsp:include (rep by Laurent Tettoni)
<li>XSL input document must use coalescing = true (rep by Marc Welk)
<li>xmlns:foo in jsp:root implicitly declares taglib (rep by Daniel Goodwin)
<li>xml:jsp should strip the XML version header (rep by rlubke)
<li>added XmlAuthenticator
<li>(2001-09-24) HTML parser needs to understand &lt;script> has implicit cdata (rep by Jakob Eriksson)
<li>directory url missing trailing '/' wasn't redirecting query string (rep by Jim Griggs)
<li>Apache setup should use '/' insteadof '\\' (rep by Arjan van Mulukom)
<li>classloader makeAll wasn't properly compiling recursively (rep by Frank Nestel and Neil Aggarwal)
<li>WEB-INF/lib was overriding the specified &lt;classpath>
<li>(2001-09-22) getRealPath was using welcome-file-list (rep by Jon Bodner)
<li>if error-page connection points to a Resin page, use default error (rep by Kirk Rasmussen)
<li>Added ApplicationAdmin.invalidateCache (rep by Joseph Dane and Steve Tekell)
<li>Added Cache-Control: must-revalidate and proxy-revalidate (rep by Joseph Dane)
<li>-compile option should allow multiple urls and add -compile-host (rep by Martin Cooper)
<li>(2001-09-20) resin:include wasn't properly restoring searchPath (rep by George Moschovitis)
<li>fixes to SchemeContext's handling of JNDI schemes (rep by David Smiley)
<li>missing jndi scheme should be treated as normal, not URLContextFactory not found (rep by Zacharias Beckman and David Smiley)
<li>JSP taglib uri can refer to jars (rep by Neil Fradkin)
<li>Fixed Alarm bug causing dropped alarms -- causing dbpool idle problems (rep by Carl-Henrik Tjarnlund)
<li>(2001-09-19) forward() should be allowed even inside body tags (rep by Alex Kotopoulis)
<li>sendRedirect has possible nullpointer with some configurations (rep by Sean Rohead)
<li>system-property allowed in &lt;web-app> (rep by Jens Moller)
<li>ClassLoaderStream rename and cleanup (rep by Jeff White)
<li>mod_caucho log should add timestamp (added! by Rob Bunten)
<li>caucho_status in mod_caucho was testing cse_open wrong (fixed! by Rob Bunten)
<li>(2001-09-18) XmlParser with multiple external entities (rep by Jean-Francois Lamy)
<li>added max-active-time to DBPool config (rep by Carl-Henrik Tjarnlund)
<li>zipFile in Jar openReadImpl wasn't properly created (rep by Sean Leach)
<li>caucho.com/var/jar-cache-size is configurable (rep by Sean Leach)
<li>When grabbing session id from SSL session, can't use '/' (rep by Jens Goring)
<li>(2001-09-17) maxPoolTime wasn't properly set (rep by Charles Meyer)
<li><2001-09-13) rotate log now uses nextPeriod calculation (rep by Jeff White)
<li>webapps change should only affect the old/new wars
<li>Change default listen to 100 (rep by Ozzy Espaillat)
<li>(2001-09-11) Allow quoted string charset: text/html; charset="UTF-8" (rep by Sean Rohead)
<li>XmlParser with Reader must ignore file's encoding (rep by Jean-Francois Lamy)
<li>JAXP support for META-INF/services
<li>include() and forward() to WEB-INF must show files (rep by Dane Foster)
<li>XML: multiple external entities weren't handled (rep by Jean-Francois Lamy)
<li>JSP and EJB classloader should use full classname for CodeSource (rep by Ashwin)
<li>make ping class-name configurable and add PingMailer (rep by Mark Saarinen)
<li>added httpd -V check in configure.in for EAPI (rep by Tauren Mills)
<li>sendRedirect needs to use host header (rep by Brandon Knitter)
<li>Apache connection error needs to use ap_internal_redirect (rep by Tom May)
<li>(2001-09-07) j_uri priority configured by form-uri-priority (rep by Tiberiu Fustos)
<li>AuthenticatorAdapter needs to have the registry passed in (rep by Grant Johnson)
<li>Auth handled by Apache/IIS wasn't passed to local auth (rep by Steve Tekell)
<li>fixed auth-config.xtp bug for form-login-config (rep by Peter Miller)
<li>added test to rotateLog to avoid 1969 los (fixed! by Jeff White)
<li>ref-ref-name should allow full path (rep by David Smiley and Neil Aggarwal)
<li>wrapper.pl should accept -no-auto-restart (rep by Tomas Loescher)
<li>getResourcePaths wasn't using getRealPath (rep by Eric Van Lydegraf)
<li>More XmlParser reuse issues
<li>(2001-09-04) nested xsl:for-each wasn't setting the context properly (rep by Stefan Scholl and Sergey Winnitsky)
<li>XmlParser wasn't properly initialized on reuse (rep by Jean-Francois Lamy)
<li>JNDI configuration in &lt;host> wasn't setting contextClassLoader (rep by Tauren Mills)
<li>removed session variable must remove value (rep by Jon Bodner)
<li>reset sessions shouldn't clear update count (rep by Jon Bodner)
<li>XmlPrinter wasn't flushing properly (rep by Jose Qinteiro)
<li>XmlPrinter should use UTF-8 as default encoding (rep by Edith Mooers)
<li>jsp-file and load-on-startup wasn't working (rep by David Smiley)
<li>filters should apply to welcome-file-list (rep by Jeremy Chone)
<li>XML declarations handled improperly in external entities (rep by Jean-Francois Lamy)
<li>JavaScript introspection needs to understand inner class constructors (rep by Michal Mosiewicz)
<li>Added XMLFilter support for JAXP (rep by Wes Hodges)
<li>Change File normalization in DOM/JAXP API (rep by Jean-Francois Lamy)
<li>QDeepNodeList needs to update length when the underlying dom changes (rep by Amit Kumar)
<li>Added setRegistry to bean initialization (rep by Colin Sampaleanu)
<li>Added Xsl command-line parameters (rep by Jean-Francois Lamy)
<li>Added servlet-classloader-hack (rep by Richard Dallaway)
<li>Added custom ErrorLog for the error-log configuration (rep by Mark Saarinen)
<li>AbstractStylesheetFactory needs to extend StylesheetFactory (rep by John Stetter)
<li>DirectoryServlet needs to accept wrappers (rep by Victor Salaman)
</ul>
</section>

<section title='2.0.2 - Aug 27, 2001'>
<ul>
<li>SAXSource.sourceToInputSource should allow non SAXSource (rep by Sean Rohead)
<li>Apache ErrorDocument must send REDIRECT_* to Resin (fixed! by Alex Leykekh)
<li>WEB-INF/classes should override WEB-INF/lib (rep by Jean-Francois Lamy)
<li>Changed StreamSource to handle files (rep by Jean-Francois Lamy)
<li>Add timestamp to ping failure. (rep by Mark Saarinen)
<li>forwarded session wasn't passed with wrapper (rep by Andrey Akselrod)
<li>caucho-status was parsed incorrectly by config.c (rep by Rob Bunten)
<li>JNDI binding with jndi-link was parsing java:comp incorrectly
<li>(2001-08-20) NT httpd wasn't setting resin.home properly (rep by Osma Ahvenlampi)
<li>DOMBuilder needs to set attribute defaults (rep by Ewan Catlanach)
<li>System.properties is now context-sensitive, i.e. separate for each web-app.
<li>access-log positive timezone should include the '+' (rep by Adrian Zimmermann)
<li>Added round_robin_random to stream.c (rep by Kaushik Banerjee)
<li>&lt;pre> and &lt;textarea> pretty-printing (rep by Zacharias Beckman)
<li>(2001-08-16) XPath filters weren't handling context properly (rep by Jean-Baptiste Quenot)
<li>META-INF/taglib.tld should be picked up automatically (rep by Barry Meyer)
<li>SchemeContext should allow '/' and ':' as separators (rep by Laurens Friedel)
<li>wrapper.pl was overwriting the "http" with "tcp" (rep by Ron Abidog)
<li>&lt;host id='*'> was confusing the plugins (rep by Nathan Paquin)
<li>Explicitly search for /Program Files/Apache Group/Apache in setup when Apache doesn't configure registry (rep by Heinz Wehner)
<li>httpd.exe -install now removes superfluous quotes (rep by Steven Cena)
<li>(2001-08-15) Set caucho.multipart.form.error for too big multipart form upload (rep by Tiberiu Fustos and Jeff Szeto)
<li>scriptlet before &lt;html> broken when too large (rep by Gerret Apelt)
<li>jsp:setProperty was confused by a getFoo(int i) in the bean (rep by Randy Kahle)
<li>Fixed regression bug for jsp tags introduced in 8-14 snapshot (rep by Andrey Akselrod)
<li>bin/resin and httpd.exe need -server-root (rep by Osma Ahvenlampi)
<li>caucho-status needs to default to false (rep by Andrey Akselrod)
<li>(2001-08-14) Multiple calls to ContextStream.setStdout would confuse the stream (rep by Dave Meissner)
<li>XSL document() needs to use XSL search path (rep by Jean-Baptiste Quenot)
<li>added html_document to alloc latin1 entities (rep by Dirk Jaeckel)
<li>mod_caucho needs set_socket_cleanup and cse_close_all for cleanup (rep by Kirk Rasmussen)
<li>nsapi plugin wasn't handling plugin_ignore (rep by Paolo Diana)
<li>New DBPool had broken ping-on-reuse (rep by Dmitri Maximovich)
<li>Check for short session to avoid Konqueror bug (rep by Mihai Christodorescu)
<li>key-size changed to key_size (rep by Kirk Rasmussen)
<li>Added jsp/recycle-tags to disable tag recycling (rep by Steve Philp)
<li>Fixed conflict with ROOT.war and resin.conf (rep by Curtis Spencer)
<li>(2001-08-11) Fixed caching sync issue which could cause infinite looping
<li>Cleanup bin/resin thread allocation to minimize thread create/destroy
<li>Both the FileServlet and CacheInvocation understand the Range header (rep by Matt Kalinowski)
<li>The javax.servlet.context.tempdir should be automatically created (rep by Mitchell Ackermann)
<li>(2001-08-09) BeanUtil configuration now accepts addXXX
<li>filters only apply to top requests (rep by Richard Vowles)
<li>Wasn't clearing buffer after CodeRed attack (rep by Steve Philip)
<li>Make DBPool serializable (rep by Chris Beck)
<li>NamedDispatcher wasn't properly handling filters, including, and chaining (rep by Zacharias Beckman) 
<li>CachePath size needs to be in bytes, not blocks (rep by Dave King)
<li>(2001-08-07) XADataSource needs to reuse connections after close (rep by Rick Hightower) 
<li>(2001-08-03) DispatchRequest shouldn't use the parent's getUserPrincipal
<li>cache memory size wasn't converting from kb to bytes (rep by Marinos Yannikos)
<li>form login must use forward for login and error pages according to spec (rep by Norm Vilmer)
<li>(2001-08-02) FreeBSD wants -lpthread in configure (fixed! by Derek Leung)
<li>Add webapps support for IIS (rep by Kevin Seguin)
<li>304 not-modified should not return content-length
<li>added max-pool-time to dbpool (rep by Charles Meyer)
<li>added jsp/disable-init-log (rep by Klaus Friedel)
<li>j_uri should have priority (rep by Robert Koburg)
<li>host matching was using strstr instead of strcmp (rep by Donald Ball)
<li>XSL document(...) call from inside included stylesheet (rep by Jean-Baptiste Quenot)
<li>XSL transform should default to UTF-8 when the output stream is an OutputStream (rep by Jean-Baptiste Quenot)
<li>XSL apply-templates does not set the context (rep by Jean-Baptiste Quenot)
<li>JarPath needs to synchronized on the jarFile (rep by Joseph Dane)
<li>(7001-08-01) mangled name for windows needs to be lower case (rep by sslindia)
<li>sendRedirect should produce absolute URL, e.g. http://foo/test.jsp (rep by Harris Wulfson)
<li>forms are allowed even when content-length < 0 because of chunked encoding( rep by Matt Stanton)
<li>fixed includes with multipart form (rep by Andrey Akselrod and Tony Nys)
<li>setpgrp should be setpgid(0, 0) (rep by Derek Leung)
<li>required Tag attributes are allowed to be the empty string (rep by Andrey Akselrod)
<li>(2001-07-31) Initial cut of AbstractLogin interface
<li>wrapper.pl -pid needs to normalize to take care of chdir (rep by Brian Stanton)
<li>xsl.Sort.cmp bug not properly testing vb for null (rep by Art Taylor)
<li>SessionStore logic for allowing non-serializable wasn't creating good files (rep by Oleg Sapojnikov)
<li>servlets weren't properly saved in instances on startup causing dual compile (rep by Rony Zacharia)
<li>HEAD wasn't working with welcome-file-list (rep by Jean-Baptiste Quenot)
<li>XSL var evaluate with string functions wasn't checking null properly (rep by Art Taylor)
<li>resin:include should use same encoding as parent (rep by George Moshovitis)
<li>error-page location must be absolute (rep by Art Taylor)
<li>(2001-07-26) External entity handling for strict-xml (rep by Jean-Baptiste Quenot)
<li>In configure.in, only use perl if the c compiler matches (rep by Simon Hobbs)
<li>MSIE hack wasn't working for contentType with charset (rep by Dave Moellenhoff)
<li>warExpandFileList wasn't properly initialized causing reload loops (rep by Charles Meyer)
<li>Cookies version 1 upgraded to rfc2965 (rep by Andy C)
<li>(2001-07-25) More Auth compatibilities
<li>URIResolver is allowed to return null (rep by Jose Quinteiro)
<li>(2001-07-24) Upgrade DBPool to allow XADataSource
<li>RunnerRequest needs to use new LOGIN_NAME from AbstractAuth (rep by Tiberiu Fustos)
<li>new stylesheet with DOM should use DOM's systemId (rep by Adolfo Aladro)
<li>missing new JSP taglib names: tag-class, etc. (rep by Andrew Akselrod)
<li>removed non-core DOM elements (rep by Dane Foster)
<li>(2001-07-23) AuthenticatorAdapter
<li>select pattern ../@foo wasn't handled property (rep by Dmitry Platonoff)
<li>classloader isModified changes and makeAll order (rep by Dave Moellenhoff)
<li>mod_caucho may have per-directory configuration (rep by ajazam)
<li>WEB-INF/lib in &lt;host> wasn't properly handled (rep by Sean Leach)
<li>Use char[] buffer in QBodyContext to speed writeOut (rep by Haining Huang)
<li>(2001-07-20) auth exception thrown in getUserPrincipal should propagate (rep by Sean Rohead)
<li>ServletServer reload could set contextClassLoader wrong (rep by Charles Meyer)
<li>XSL document() needs to rethrow exceptions (rep by Adolfo Aladro)
<li>(2001-07-19) Compile problem with jsp:setParameter with multiple array values (fixed! by Hannes Loubser)
<li>listener classes can implement multiple interfaces (rep by Max Kutny)
<li>error parsing XML with external DTD (rep by James Bond and Jean-Baptiste Quenot)
<li>XSL document() needs to be relative to the stylesheet (rep by Jean-Baptiste Quenot)
<li>war-dir and war-expand-dir need to be aware that File.list() might not return a consistent order (rep by Charles Meyer)
<li>reload of war would append web.xml to old registry (rep by Charles Meyer)
<li>responseAdapter.addIntHeader was calling setIntHeader (fixed! by Brian Ewins)
<li>(2001-07-17) Initial cut of SQL rewrite and DB clustering (rep by Jeremy Randall and Chris Beck)
<li>(2001-07-16) Initial cut of authentication rewrite (rep by Sean Rohead)
<li>ETag needs to be quoted, e.g. ETag: "fffzzz" (rep by Brian Ewins)
<li>(2001-07-11) Added custom access logging with access-log/log-class (req by Marcus Stein)
<li>Added response for sendRedirect for stupid wap browsers (rep by Harris Wulfson)
<li>Added initial cut for the security-manager (rep by Tauren Mills)
<li>added stdout-log and stderr-log in web-app (rep by Jeff White)
<li>error-log rollover settings for virtual host were ignored (rep by Jeff White)
<li>jsp:getProperty and jsp:setProperty should allow case insensitive props (rep by Richard Stoller)
<li>endTagHack nullpointer with empty body tag (rep by Ovidiu Ionescu)
<li>PageContext.XXXAttribute needs to check session for null (rep by Martin Cooper)
</ul>
</section>

<section title='1.2 snap - Oct 26, 2001'>
<ul>
<li>(2001-10-26) Response.finish with forward() needs to skip input stream (rep by Song Qiu)
<li>Taglib jar lookup backpatched from 2.0 (rep by Neil Fradkin)
<li>bin/resin request_parse_headers needs to deal with long headers (rep by Stefan Praszlawicz)
<li>With Apache, wasn't reloading servlets (rep by Guy McArthur)
<li>Wasn't clearing buffer after CodeRed attack (rep by Steve Philip)
<li>sendRedirect should produce absolute URL, e.g. http://foo/test.jsp (rep by Harris Wulfson)
</ul>
</section>

<section title='2.0.1 - July 10, 2001'>
<ul>
<li>(2001-07-09) isapi_srun wasn't tracking active_connections for load balancing
<li>round robin load balancing fixes
<li>Multiple &lt;% ... %> allowed for XTP special parsing
<li>(2001-07-05) file servlet needs to deal with filters and wrappers (rep by Bryan Young)
<li>xsl:use-attribute-sets for literal element (rep by Jean-Baptiste Quenot)
<li>forward() query string needs to be aggregated (rep by Chris Monster)
<li>context class loader needs setting in Application.init (rep by Frank Nestel)
<li>(2001-07-04) mod_caucho doesn't need per-request config (rep by Carlos)
<li>getResourcePaths implemented (rep by Davis Koblas)
<li>session isolation with getContext and forward (rep by Christian Sell)
<li>Changed compiler timeout message (rep by Jens Goring)
<li>jsp:setParameter regression failure from snapshot (rep by Serge Popov)
<li>XSL precompilation wasn't detected with StreamSource (fixed! by Andrey Novik)
<li>XSL imports and includes with StreamSource weren't paying attention to System ID (fixed! by Andrey Novik)
<li>SystemId was ignored in stylesheet newTemplates (fixed! by Andrey Novik)
<li>Added Reader support for stylesheet Source (added! by Andrey Novik)
<li>Added URIResolver support for stylesheets (added! by Andrey Novik)
<li>welcome-file-list needs to check authorization (rep by Sean Rohead)
<li>CDATA printing didn't close the element (rep by Fernando Herrero)
<li>(2001-07-02) AbstractCompiler error messages
<li>added mod_caucho/resin ssl support (rep by Chun Heng Lum)
<li>(2001-06-28) added jsp:setProperty support for long[] (rep by Ethan Adams)
<li>&lt;classpath id='http://foo.com:8080/classes'> supported (rep by Dimitri Rakitine)
<li>Xml parsing wasn't properly recording dependencies (rep by Ron Hart)
<li>improved servlet failure error messages (rep by Jose Manuel Cantera Fonseca)
<li>isSupported() needs to work for document element too (rep by Felix Gnass)
<li>Fixed QDate parsing to handle Netscape's ;length=40  (rep by Frank Nestel)
<li>Added ETag support to HttpServlet (rep by Frank Nestel)
<li>(2001-06-26) war-expand-dir last-modified wasn't properly recorded (rep by Roger Kjensrud)
<li>Added bin/resin support for multiple ports and openssl (rep by Dmitri Platonoff)
<li>JSP can't override destroy() for extends classes (rep by Dimitri)
<li>owner.changeCount++ needs test if owner == null, e.g. for dtd nodes (rep by Christophe Condomines)
<li>In FormLoginServlet, request.getSession() should be after login (rep by Sean Rohead)
<li>resin.conf error should allow fixes for problems outside the web-app (rep by Frank Nestel)
<li>added &lt;interface host='localhost' port='8080'/> to security-constraint (rep by Rene Trussell-Cullen)
<li>For windows ensure case-sensitive check for CompilingClassLoader (rep by Alan Berezin)
<li>servlet.init method must be allowed to call request dispatcher (rep by Gerret Apelt)
<li>server vs host vs web-app vs web.xml priority was confused (rep by Robert Gagliardo)
<li>classpath id='WEB-INF' must be treated as default for web-app (rep by Brian Beaulieu)
<li>CauchoHost wasn't handled properly with new srun impl (rep by Ashish Khosla)
<li>jndi-link wasn't handling foreign contexts (rep by Dmitri Maximovich)
<li>httpd-port and srun-port now throw exceptions
<li>ReaderWriterStream chopping off utf-8 bytes (rep by Jakob Eriksson)
<li>Xml.parseDocumentString must ignore encoding and use utf-8 (rep by Jakob Eriksson)
<li>XML '\n' entities in attributes were broken (fixed by Jakob Eriksson)
<li>XmlPrinter must escape '&lt;' and '&gt;' in attributes (rep by Jakob Eriksson)
<li>added exception-on-timeout to DBPool config (rep by Steve Philip)
<li>ResponseAdapter.close() needs to use correct encoding (rep by romario)
<li>cleanup tcp-ring loadSelf error messages (rep by Meeraj Kunnumpurath)
<li>revise nsapi init order to fix g_config assignment (rep by Paolo Diana)
<li>cleaup cse_init update (rep by Tom May)
<li>isapi_srun was shortening response headers
<li>persistent serialization errors should be logged automatically
<li>Added AbstractAuthenticator options (rep by Francois Bertrand)
<li>FileServlet needs to handle filter wrappers (rep by Bryan Young)
<li>fixed cp1252 encoding (rep by Pedro Beck Gomes da Costa)
<li>Added work-dir to web-app configuration (rep by Magnus Nordseth)
<li>body tag can return EVAL_BODY_INCLUDE (rep by Michal Mosiewicz)
<li>added LexicalHandler support for CDATA and comments (rep by Robert Koberg)
<li>stylesheets for vary example should allow vary.xtp directly
<li>JavaScript var printing when forced from variable to global (rep by Stanislav Devyatovskiy)
<li>JSP tag setParent(null) needs cast (rep by Michal Mosiewicz)
<li>bin/resin was returning canonical host for getServerName, not the virtual host (rep by Jean-Baptiste Quenot)
<li>bin/resin now handles multiple ports (rep by Dmitri Platonoff)
<li>log session serialization errors (rep by Stephen Tenberg)
<li>ROOT web-app wasn't recognized (rep by Michael Miller)
<li>Continuation headers are used by Opera (rep by Stefan Alexandrescu and Oliver Koell)
<li>remove trailing '\' from httpd.exe classpath (rep by Oliver Henlich)
<li>potential buffer overflow in isapi_srun.dll (rep by Netcraft)
<li>handleCron in RotateStream needs to synchronize the stream (rep by Tom May)
<li>getElementsByTag name must be live (rep by Jakob Eriksson)
<li>transform needs to handle StreamSource.getReader() (rep by Wes Hodges)
<li>transform needs to handle StreamResult.getWriter() (rep by Wes Hodges)
<li>Apache 2 needs to use ap_get_server_name (rep by Dave Wallace)
<li>nested &lt;%@ include %> didn't reset pwd properly (rep by Stanislav Devyatovskiy)
<li>.war update on windows needs to deal with the windows non-delete of busy file issue (rep by Frank Carver)
<li>XslParser needs to use QElement, not CauchoElement (rep by Frank Carver)
<li>java compilation needs better error message when internal fails or the external compiler is missing (rep by Paul Freeman)
<li>add GBK to Encoding.java (rep by leoding)
<li>setup.exe needs to put LoadModule and AddModule in right order (rep by Engst Oliver)
<li>getElementByTagName fails with no children (rep by Trevor Baker)
<li>JSP contentType must be copied verbatim (rep by Tomas Zeman)
<li>servletPath and servletPath + pathInfo need path-mapping (rep by Jean-Baptiste Quenot)
<li>servletPath + pathInfo must be allowed as JSP (rep by Paul Brown)
<li>'+' needs to be allowed in mailto names (fixed! by Todd Lipcon)
<li>caucho_dispatch needs to occur after url->filename mapping to support mod_dir (rep by Henrik Schack)
<li>stream.c create too large of a static data structure (rep by Phil Eschallier)
<li>HardCore should not be enabled by default (rep by Carlos)
</ul>
</section>

<section title='2.0.0 - June 8, 2001'>
<ul>
<li>JNDI needs to set itself in classloader before calling jndi-link (rep by Joseph Dane)
<li>Tags shouldn't be pooled across instances (rep by Michal Mosiewicz)
<li>FormLogin forward needs to check auth (rep by Martin Cordoba)
<li>jsp/jsp-max needs to limit total number of JSP pages (rep by Mark Wilkie)
<li>basic jsp:text and jsp:root support.
<li>Major fixes to HardCore POST support.
<li>CharBuffer.getChars() would loop forever (rep by Wallace Roberts)
<li>stylesheets and XTP files now generate temp files in WEB-INF/work.
<li>added config-update-interval to web-app (rep by Bill Marcum)
<li>StringStream, PipeStream, and ReaderWriterStream had bad write() impl (rep by Jean-Baptiste Quenot)
<li>session-config/cookie-max-age (rep by Mark Saarinen)
<li>"JAVA" encoding for XSL stylesheets (rep by Jean-Baptiste Quenot)
<li>host id='foo.com:8080' should only match port 8080 (rep by Lee Chin Peng)
<li>For Apache2, mod_caucho can handle &lt;Location> configuration
<li>share mod_caucho sockets across virtual hosts (rep by Brian Beaulieu)
<li>sessions using SSL sessions (rep by Hoong Wai Wong)
<li>.asf .asx mime-types (rep by Joe Busch)
<li>Make AbstractRequest to work around PHP bug (repb y Wallace Roberts)
<li>connection count based load balancing
<li>Apache2 support for mod_caucho.c
<li>Performance fixes for taglibs.
<li>web.xml encoding for non-UTF-8 was broken (rep by Frank Nestel)
<li>error-log can now have rollover-size and rollover-period (rep by Mark Kreklau)
<li>Generated JSP classes are now put in WEB-INF/work
<li>position() and last() support for apply-templates (rep by Stefan Scholl)
<li>&lt;log> now supports rollover-period (rep by Heather Grace)
<li>SAXTransformerFactory needs to extend TransformerFactory (rep by Stephane Bailliez)
<li>Randomize the round_robin_index on Apache client start (rep by Mark Berry)
<li>jndi hack and cleanup of dynamic class loader (rep by Frank Nestel)
<li>Added &lt;sticky-sessions> configuration (rep by George Pearson)
<li>Log errors and recover better with .war expansion fails (rep by Matt Grimm)
<li>Better error messages for servlet instantiation issues (rep by Gerret Apelt)
<li>Form handling no longer uses the response content type (rep by Serve Popov)
<li>single signon across &lt;host> or &;http-server> (rep by Dave Dribin)
<li>JSP file wasn't reusing the allocated tags (rep by Mac Ferguson)
<li>Make xml/parsers classes public to support JDOM (rep by Colin Sampaleanu)
<li>run-at dummy response should return valid getWriter(), but to /dev/null (rep by Brian Keefe)
<li>Added run-at/period (rep by Frederic Giust)
<li>Changed Alarm to use linked-list instead of ArrayList (rep by Neil Fradkin)
<li>DynamicClassLoader now extends SecurityClassLoader (rep by Ron van Pol)
<li>getRequestURL in forward() was using old value (rep by Christian Sell)
<li>added com.caucho.security.SecurityContext to support EJB.
<li>added allow-admin to web-app and ApplicationAdmin (rep by Heather Grace)
<li>Exceptions in DBPool are now properly wrapped.
<li>jndi-link needs to use an ObjectProxy to handle foreign JNDI updates (rep by Alf Werder)
<li>Using Perl as a heuristic in ./configure to guess compile flags
<li>Allow web-xml to be configured (rep by Adolfo Aladro)
<li>Allowed the session-url-prefix to be configured (rep by Peter Andrews)
<li>Better error reporting for classpath/library-dir (rep by HYN)
<li>Added AttributeListIterator to handle foreign DOMs (rep by Jakob Eriksson)
<li>Errors in web.xml shouldn't disable the server on startup (rep by Marcus)
<li>Add cache enable=false to disable the cache (rep by John Moore)
<li>classloader in host context needs init (rep by Qiao Jin)
<li>getProperty wasn't finding values properly (rep by Patrik Laszlo and Dave Dribin)
<li>Duplicate instantiation in Taglib (rep by Ralf Beier)
</ul>
</section>

<section title='1.2.8 - July 11, 2001'>
<ul>
<li>potential buffer overflow in isapi_srun.dll (rep by Netcraft)
<li>JSP contentType fix (rep by Tomas Zeman)
<li>Alarm change since volatile long is guaranteed atomic (rep by Tom May)
<li>close_child in mod_caucho.c had incorrect test (fixed! by Mario Bulhoes)
<li>TcpServer.startConnection could increment startCount w/o starting thread (rep by Daniel Wroblewski)
<li>internal compiler issue with i18n (fixed! by Tatsuya Bizenn)
</ul>
</section>

<section title='1.2.7 - May 31, 2001'>
<ul>
<li>Apache/IIS with query string (rep by everybody)
<li>findSessionIdFromCookie needs to deal with null CookiesIn (rep by Gonzalo Diethelm)
</ul>
</section>

<section title='1.2.6 - May 30, 2001'>
<ul>
<li>detect Solaris Interrupt in waitForExit (rep by Kirk Rasmussen)
<li>nsapi.c needs to look for ;jsessionid= not ;JSESSIONID= (rep by Tomasz Karpowicz)
<li>BasicPrincipal needs to be serializable (rep by Jim Frenette)
<li>plugin cleanup to avoid post issues (rep by Claus Jacobsen)
<li>better detection/recovery of accept interrupts (rep by Daniel Wroblewski)
<li>mod_caucho rewrite of ;jsessionid= must update stat info (rep by Robert Binion)
<li>Create relative paths for jikes compilation on win32 (rep by James Korotney)
<li>&lt;classpath source='.'/> caused compilation errors (rep by Peter Andrews)
<li>Locale "zh" should be mapped to GB2312, not BG2312 (rep by Riew)
<li>Exception in HTTP request parsing must close connection (rep by David Hammerton)
<li>Too-many SSL exceptions should stop the server (rep by Jonas)
<li>always-load-session wasn't accepting "false" (rep by Mark Saarinen)
<li>changed wrapper.pl setpgrp(0,0); to setpgrp; to fix Solaris (fixed! by Guy McArthur)
<li>ServletInputStream wasn't returning lines w/o newline.
<li>web.xml must support xml:param='preserve' (rep by Mark Owen)
<li>JSP headers in XTP should still allow doctype decl (rep by Soon Shin)
<li>IIS with query strings was causing not found exceptions (rep by Mark Saarinen)
<li>JavaScript wrapping of classes named $Foo was broken (rep by Claude Pelletier)
<li>JavaCompiler should not normalize the encoding to the Java name (rep by Dmitry Sevostyanov)
<li>Check war-dir change using list() instead of just lastModified for NT.
<li>NT wasn't detecting jar additions to WEB-INF/lib.
<li>DirectoryServlet needs to use URLUtil.encode (fixed! by Justin Akehurst)
<li>Bug in XPath FromRoot when node is null. (fixed! by Bruno Navert)
<li>JniRequest and proxy.h need to sync buffer sizes (rep by Istvan Ratkai)
<li>CharBuffer.getChars wasn't incrementing properly (fixed! by Lolo LaSida)
<li>in wrapper.pl -green and -classic need to be first (rep by Terence Parr)
<li>Request Content-Type charset allows quotes (fixed! by Philip Nelson)
<li>URL // should be synonym of root (rep by Ken Miyaki)
<li>duplicate data sources are not detected (rep by C. K. Lim) 
<li>&getcwd is buggy in wrapper.pl, use getcwd() instead (fixed! by Adam Ryba)
<li>Duplicate JSP page encoding with same encoding should be allowed (rep by George Moschovitis)
<li>&lt;embed> cannot have pretty-print spaces added (rep by Stefan Scholl)
<li>AT_BEGIN tags need to be updated in loops (rep by Bindu Mohan)
<li>check war-expand-dir for modifications
<li>expose Response.getContentLength() as public (rep by Carl-Henrik Tjärnlund)
<li>If no cookies in Request.getCookies() should return null (rep by Pierre-Yves Saumont)
<li>response.setContentType was ignoring parameters like ";boundary" (fixed! by Joe Zimmerlin)
<li>isapi_srun needs better error-handling for bad resin.ini (rep by Frank Nestel)
<li>URLUtil needs to encoding '%' (rep by Martin Cooper)
<li>Fixed jsp_precompile (rep by Martin Cooper and Serge Knystautas)
<li>HttpUtils wasn't parsing long POST forms (rep by Robert Whittle and Gustavo Santucho)
<li>SmtpStream wasn't handling multiline SMTP responses properly (fixed! by Michael Kolfman)
<li>JSP tag values containing quotes weren't properly escaped (rep by Hans Bergsten and Mikael Andersson)
<li>CharBuffer.replace wasn't setting the length (rep by Alan Berezin)
<li>getElementsByTagName shouldn't include the tag itself (rep by Jakob Eriksson)
<li>CpXXX encodings should use CpXXX as the mime-type (rep by Serge Popov)
<li>security fixes (rep by Kristoffer Karlsson and Huang YingNing)
<li>jsp:setProperty error message bugs (rep by Eric Rasmussen)
<li>Several bugs with tcp-store and different crash/restore orders (rep by Gary Doughty)
</ul>
</section>

<section title='2.0.b2 - April 17, 2001'>
<ul>
<li>Reorg XPath preparing to support XSLT 1.1
<li>reworked vfs.i18n to make it easier to add other encodings
<li>break up XSL template init to avoid Java method limits (rep by Jean-Baptiste Quenot)
<li>IIS getRequestURI() needs to be re-escaped (rep by Frank Nestel)
<li>exclude-result-prefixes wasn't working with new XSL (rep by Jean-Baptiste Quenot)
<li>Session destroy events need to be called even with empty sessions (rep by Deepak Sharma)
<li>added resin:disable-output-escaping as synonym for disable-output-escaping at top (rep by Stefan Scholl)
<li>position() in sort needs to use sort order, not doc order (rep by Peter Heinrich)
<li>Initial JAXP 1.1 cut
<li>XTP with lots of parameters needs to hash mangled class name (rep by Jean-Baptiste Quenot)
<li>XML/XSL redesign
<li>merge with 1.2snap fixes
<li>Need to set javax.servlet.error.request_uri (rep by Serge Knystautas)
<li>Tag library performance optimization
<li>Cookies need space between ;Path (rep by Sunny Balijepalli)
<li>HardCore small POST
<li>HardCore basic caching
<li>HardCore date generation
</ul>
</section>

<section title='1.2.5 - April 12, 2001'>
<ul>
<li>Regression failure with a.jsp/foo.jsp
</ul>
</section>

<section title='1.2.4 - April 11, 2001'>
<ul>
<li>return error page on basic auth forbidden (rep by Mark Ashworth)
<li>IIS 5.0 auth fixes (fixed! by Ahn Le)
<li>more NT filepath garbage (rep by Huang YingNing)
<li>cleaned up SchemeContext lookup of non-existent file (rep by Dave Moellenhoff)
<li>WriteStream needs to check "source" again when flushing (rep by Stephen Wong)
<li>application["caucho.server-id"] has the server id (rep by Bill Horsman)
<li>better error reporting for interpolated values (rep by Roger Kjensrud)
<li>tcpServer array not properly initialized in ResinServer (fixed! by Mathias Lagerwall)
<li>AIX lockup: read_length in ReadStream shouldn't ever be < 0. (found! by Ganesan Venkatasubramanian)
<li>directories/files starting with '.' should not be compiled (rep by Todd Lipcon)
<li>JniRequest.getReader() was broken (rep by Istvan Ratkai)
<li>XmlPrinter.print needs to flush for wrapped streams (rep by Chris Cuilla)
<li>srun backup order was inconsistent (even/odd) (rep by Tony Payne)
<li>cleanup encoding on close() and limit char[] size in WriteStream (rep by Peng Yong)
<li>.jsp issues (rep by Elias Levy)
<li>hash remote ip in generated session id (rep by Franck Bombourg)
<li>better error message with XmlPrinter using writer and encoding (rep by Calh-Henrik Tjarnlund)
<li>getNamedDispatcher wasn't forwarding() property (rep by Ralf Beier)
<li>servlet errors on init() need to be logged (rep by Charles Meyer)
<li>jikes problems with compilation (rep by Dave Moellenhoff)
<li>add multiple parameters to env.jsp (added! by Martin Cooper)
<li>mod_caucho should strip url-encoding from static files (rep by Kirk Rasmussen)
<li>old srun sockets need closing (rep by Sang Yi)
<li>Invalidated TCP ring sessions need to be removed on restart (rep by Christian Kindler)
<li>IP printing bug in access logging (rep by Frits Jalvingh)
<li>Need to strip leading whitespace for IIS headers (rep by Martin Jerico)
<li>Better recovery for standalone request -e index.xtp, i.e. no / (rep by Richie Bielak)
<li>Setting doctype-system should be in Document.setProperty (rep by Boris Granveaud)
<li>Fixed incorrect DOCTYPE for HTML (rep by Paul Brown)
<li>sendRedirect HTTP/1.1 needs to allow keepalive or send Connection: close (rep by Hoong Wai Wong)
<li>NT bin/httpd.exe now has -EPATH=foo to set environment variables (rep by Christian Plonka)
<li>RunnerRequest needs to grab the server port (rep by Stephen Tenberg)
<li>Path.normalize needs to leave trailing '/'
<li>wrapper.pl should use 127.0.0.1 instead of INADDR_ANY (rep by Anthony Tonns)
<li>can't connect must return 503, not 500 (rep by Bernshtam Pavel)
<li>Make JspLineException serializable (rep by Diego Martin Sabaris)
<li>Increate srun-socket timeout (rep by Robert Armstrong)
<li>NodeTransformer must set system-id and public id (rep by Boris Granveaud)
<li>SendRedirect shouldn't normalize queryString (fixed! by Martin Cooper)
<li>QElement.print needs to cast children to QAbstractNode (rep by Tomas Bahnik)
<li>character-encoding was ignored in application (rep by Frank Nestel)
<li>&lt;%@ include %> with url-pattern='/*' breaks (rep by Andrej Gabara)
<li>NT case insensitive could cause double servlet load (rep by Jan Svensson)
<li>NT service must catch ctrl-break (rep by Tarvis Romney)
<li>add entire certificate chain as javax.servlet.request.X509Certificate.chain (added! by Yori Sakakura)
<li>need to check JspFactory.getDefaultFactory before setFactory (rep by Randy Kemp)
<li>need to escape &lt; for file not found (rep by Hiromitsu Takagi)
<li>Fixed StringTransformer encoding issues (rep by George Moshovitis)
<li>mod_caucho needs case-insentivie host match (rep by David Cruz Langreo)
<li>Base64 decode must ignore spaces (rep by flare)
<li>CompilingClassLoader must not delete .class unless there's a .java (rep by Daniel Kirk)
<li>character-encoding should not automatically affect compilation (rep by Frank Nestel)
<li>content-length missing on some caching cases (rep by Lars Haupt-Hansen)
<li>added XmlParser.setDefaultEncoding (rep by Frank Carver)
<li>welcome files need passed parameters, e.g. for /foo/?id=a (rep by Jean-Baptiste Quenot)
<li>forwarded request parameters need to handle i18n encoding (fixed! by Stanislav Debaltchouk)
<li>Added entities-as-text init-param for XtpServlet (rep by Dariusz Wojtas)
<li>Cron needs to start at hh:mm:01 instead of :00 so run-at will have correct time (rep by Mats Ekberg)
<li>taglib uri='foo.tld' should check web-app root (rep by Julie Melbin)
<li>Resin shouldn't use BeanInfo to get attributes and properties (rep by Mike Wynholds)
<li>HttpUtils.getRequestURL needs to grok SSL port 443 (rep by Alex Gleyzer)
<li>wars should get all plugin requests (rep by Colin Hawkett)
<li>Make log rollover count configurable (rep by Jeff W)
<li>Resin documentation XSL changes to handle web-apps (rep by James Korotney)
<li>xmlns should be ignored by JSP parser (rep by darkness)
<li>exclude-namespace-prefixes should be exclude-result-prefixes (rep by darkness)
<li>::$DATA issue (rep by Rosinei Muniz)
<li>ByteToChar.addByte() needs to loop until ring clears (rep by Timur H.Evdokimoff)
<li>XslParser needs to understand namespaces (rep by darkness)
<li>mailto: missing date (rep by Alex Sharaz)
<li>XslFilter must not copy input headers to output (rep by Pieter Schoenmakers)
<li>i18n form handling with JDK 1.1 is different from 1.2 (rep by Serge Popov) 
<li>bin/resin now uses GetPrimitiveArrayCritical (rep by Vickie Yang)
<li>JniRequest wasn't properly setting the date
<li>getHeaderBuffer bug in JniRequest breaks post (rep by Ratkai Istvan)
<li>XslWriter needs to send the xmlns url with its attribute (rep by darkness)
<li>plugin wasn't ignoring spaces in web.xml properly (rep by Serge Popov)
<li>must call setBodyContent(null) when doStart fails (rep by David Geary)
<li>duplicate web-app now throw an error message (rep by Emily Voytek)
<li>bin/resin sync/disconnect fixes preventing page sharing (rep by Ian Beard)
<li>work-dir should allow Java properties work-dir='$foo' with -Dfoo=bar (rep by Andrej Gabara)
<li>normalize paths in wrapper.pl so chdir won't break relative paths (fixed! by Mike Wynholds)
<li>resin.conf examples need &lt;srun> (rep by Mike Wynholds)
<li>init.resin needs to use $EXE (rep by Martin Decker)
<li>Cookies need space between ;Path
<li>do not add *.jsp and *.xtp to plugin map (rep by Andrew Boyko)
<li>symlink to empty webapp not treated as a directory (rep by Pieter Schoenmakers)
<li>Registry parsing should let SAX parsers return multiple characters() (rep by Frank Nestel)
<li>'#' must not be treated specially in the URL (rep by Mark Berry)
<li>NullPointer for bin/resin with logging enabled (rep by Ratkai Istvan)
<li>Added Cp866 and other MS-DOS code pages to known encodings (rep by Serge Popov)
</ul>
</section>

<section title='1.1snap - March 12, 2001'>
<ul>
<li>mod_caucho needs case-insensitve host match (rep by David Cruz Langreo)
</ul>
</section>

<section title='1.3.beta1 - Jan 29, 2001'>
<ul>
<li>Servlet 2.3 request.setContentEncoding
<li>Servlet 2.3 listeners
<li>include() and forward() need to allow wrapped requests (rep by David Geary)
<li>JSP 1.2 variable declaration in tld
<li>Resin HardCore<sup>tm</sup> initial implementation
<li>JSP 1.2 IterationTag
<li>JSP 1.2 TryCatchFinally
<li>NT service name changed to Resin (rep by Colin Sampaleanu)
<li>Initial cut of Servlet 2.3 filters
</ul>
</section>

<section title='1.1snap - March 1, 2001'>
<ul>
<li>Solaris client disconnect fixes patched from 1.2
</ul>
</section>

<section title='1.1.6 - Feb 13, 2001'>
<ul>
<li>NT .. issues
<li>tag-location needs to allow absolute paths (rep by David King)
<li>tag-location needs to look in classpath (rep by David King)
<li>limit on headers too small in resin 1.1 (rep by Torben Bruun)
<li>%00 issues (rep by Jonah Kowall)
<li>mod_caucho changed r->unparsed_uri to r->uri (rep by Walter Holladay)
<li>print exception log even when there's an error page (rep by Dave King)
<li>ClientDisconnectException wasn't properly propagates in JSP (rep by Daniel Spichty)
<li>web-app id='foo' has wrong default app-dir (rep by James Korotney)
<li>close() synchronization issue causing premature close
<li>class.path and sun.boot.class.path are both needed for jikes (rep by James Korotney)
<li>POST needs to read all the data for a sendRedirect (rep by Alan Berezin)
<li>war at non-top-level weren't expanded (fixed! by James Ralston)
</ul>
</section>

<section title='1.2.3 - Feb 15, 2001'>
<ul>
<li>Document.getElementById() wasn't implemented (rep by Carl-Henrik Tjarnlund)
<li>application.getResource() wasn't returning jars properly (rep by Peter Mudima)
<li>Caching issues when first request is HEAD (rep by Andrej Gabara)
<li>XTP html-to-lower detection broken (rep by Gerret Apelt)
<li>URL context factory fixes (rep by Nina Berezinsky & Christian Plonka)
<li>AT_BEGIN jsp tag variable needs update AT_END (rep by Todd Fast)
<li>directory listing needs to encode %20 for spaces (rep by Troy Engel)
<li>must not save cookie in cache
<li>added forbid-host to forbid hostile IP addresses
<li>change single-host server lookup (rep by Brandon Knitter)
<li>cleanup socket write stream.c to handle short writes
<li>allow assignment of smtp sender='foo@bar.com' in resin.conf (fixed! by Matthew Hixson)
<li>jar reloading issues (rep by Frank Nestel)
<li>Use request's encoding as default encoding for multipart stream (fixed! by Rick Lei)
<li>possible synchronization issues in CacheInvocation
<li>jsp:declaration allowed inside tags (rep by Julie Melbin)
<li>Improve random number seeding for session id generation (rep by Jeff Trimm)
<li>On java.lang.Error in JSP page, force a recompilation (rep by Guy Tal)
<li>isapi_srun.dll wasn't matching /* at root web-app (rep by Nicolas Lehuen)
<li>added war-expand-dir (rep by George Cai)
<li>plugins need to look in work/_war for expanded wars (rep by Colin Hawkett)
<li>added DBPool.setConnectionWaitTime(long time) (rep by Walter Holladay)
<li>;jsessionid processing was confused with %20 escapes (rep by Frank Nestel)
<li>added SessionBacking and significanly rewrote the distributed ring
<li>class-update-interval needs to be a period (rep by Damien Mascord)
<li>caching race with setting content-length (rep by Todd Carmichael)
<li>request.getDate() not properly set for keepalive connections
<li>IIS plugin wasn't detecting class changes! (rep by Igor Kolomiyets)
<li>isapi_srun.dll enhancements for client certificates (added! by Ahn Le)
<li>force xpath/xsl to use Resin's XML to avoid DOM issues
<li>nsapi.c string returned by util_hostname() must be strdupped (fixed! by Casu Alain)
<li>when not precompiling, force load of page even when modified (rep by Geert Van Damme)
<li>cookie-auth-update was documented wrong (rep by Martijn Sprink)
<li>taglib lookup fixes (rep by Frank Nestel and Rickard Oberg)
<li>Need to catch throwables from servlet.init and servlet.destroy (rep by Horst Reiterer)
<li>xtp/jsp parsing of attributes now supports "foo&lt;%= "a" %>bar" (rep by Peter Andrews)
<li>bin/resin needs to obey host and -server (rep by Ratkai Istvan)
<li>HttpStream needs to read results before recycling - ping issue (rep by Carlos Moreno)
<!--
<li>entities-as-text should not be changed with auto-xml (rep by Jean-Baptiste Quenot)
-->
<li>isapi_srun.dll needs to use browser redirect for connection failure (rep by Carlos Moreno) 
<li>Anchors should be ignored (rep by Kirill Maximov)
<li>TagData.getAttributes() missing (rep by James Korotney)
<li>NT security issue (rep by Joe Testa)
<li>distributed session issues with virtual hosts (rep by Tony Payne)
<li>distributed-session-directory configurable (rep by Dustin Sallings)
<li>The old value of XPath more-positions wasn't properly saved (rep by Sergey Winnitsky)
<li>With persistent sessions, request.getSession(false) should return the saved session. (rep by Dmitri Maximovich)
<li>i18n for Form parameters doesn't handle spaces correctly (rep by Timur Evdokimoff)
<li>Application.cron() close() and timeout() need setContextClassLoader (rep by Daniel Wroblewski)
<li>several misc distributed session fixes
<li>Special HTML parsing for XTP (rep by Peter Andrews)
<li>Add alarm so long external compile jobs get stopped.
<li>Allow $resin_home/foo/bar.jar in classloader (rep by BER Adrian)
<li>releasePageContext should be in a finally block (rep by Yori Sakakura)
<li>added newStylesheet(Reader) method (rep by Dariusz Wojtas)
<li>cache-mapping expires=0 should not set an expires time (rep by Bernshtam Pavel)
<li>HttpSessionBindingEvent order fixes for invalidation (rep by Graham Lea)
<li>bug in TagAttributeInfo.getIdAttribute()
<li>reuse TCP connections for tcp-store
<li>added srun-index to &lt;srun> configuration (rep by Christian Carstensen).
<li>tcp-distributed sessions could use old values when owning host restarts (rep by Osma Ahvenlampi)
<li>always-save-session was inverted! (rep by Travis Atkins)
<li>XML Parsing from InputStream wasn't handling search path dtd correctly (rep by Frank Carver)
<li>XTP &lt;% ... %> needs an implicit cdata (rep by Peter Andrews)
<li>TcpServer.isDead() needs to check if the TcpServer thread is alive (rep by Daniel Wroblewski)
<li>XTP init-parameter html-to-lower can be set false to avoid normalization (rep by Peter Andrews)
<li>Pretty-printing empty option with no end tag (rep by Peter Andrews)
<li>Added &lt;option name="foo" &lt;%= xxx %>> hack. (rep by Peter Andrews)
<li>added save-on-shutdown (rep by Philip Nelson)
<li>Added -server-root to wrapper.pl for ISPs (rep by Jason Taylor)
<li>webmacro needs Response to be public (rep by Michael Mutschler)
</ul>
</section>

<section title='1.2.2 - Jan 16, 2001'>
<ul>
<li>Cookie.setDomain needs nullpointer check (rep by Heather Grace)
<li>QPooledConnection needs to allow createStatement even with ! isValid (rep by Pieter Schoenmakers)
<li>WAP default extensions (added by Amy Wan)
<li>Response.setIntHeader() was calling cb.close() causing a double reference (fixed! by Dave Wallace)
<li>fixed bin/resin C initialization errors
<li>cleared pageXXX fields in Dispatch Request (rep by Neeme Praks)
<li>waitForExit must catch SocketException because client disconnect on solaris will throw SocketExceptions on all sockets (rep by Robert Mitchell)
<li>when possible, initialize the server before listening to ports (rep by Neeme Praks)
<li>isapi_srun.dll wasn't grabbing the cookie properly (rep by Philip Nelson)
<li>stream.c wasn't properly paying attention to dead-time
<li>isapi_srun.dll must look in registry before c:\resin
<li>configException needs to be logged (rep by Walter Holladay)
<li>i18n form parameters weren't fully read (rep by Rick Lei)
<li>DynamicClassLoader needs to clear attributes on unload to work around JNDI memory bug
<li>strict-mapping wasn't handling *.jsp properly (rep by Khang Nguyen)
<li>server restart must only happen on top-level requests
<li>server restart needs to clear the invocation cache
<li>find *.tld in META-INF and WEB-INF
<li>significant cleanup of caching (rep by Brian Hauer)
<li>i18n form parameters with non-escaped chars not treated as chars (rep by Rick Lei)
<li>weekly logging should start on Sunday, not Wednesday
<li>default url-mapping="/" needs to set servletPath to the whole servlet (rep by Neeme Praks)
<li>Pruning of the tail of XPath select patterns tail, causing slow XSL (rep by Pieter Schoenmakers)
<li>JSPs in WEB-INF needs to be hidden from browser, but allowed by
forward or include
<li>taglib-location with a *.jar needs to add the jar to the classpath (rep by Rickard Oberg)
<li>XSL namespace test for 1992/XSL/Transform must not match .../TransformFoo (rep by John Kozak)
<li>DBPool changes to load drivers from app class loader (rep by Robson Miranda)
<li>Pipelining needs to force keepalive (rep by Brian Hauer)
<li>Not Modified response was returning old expires (rep by Brian Hauer)
<li>authenticator needs application classloader (rep by Vitaly Batychko)
<li>make error messages XHTML compatible (rep by Dmitri Maximovich)
<li>XSL close tag should report missing open tag (rep by Timur Evdokimoff)
<li>Server reload on resin.conf change has alarm and cron problems (rep by Khang Nguyen)
<li>xmlns for "default" namespace wasn't printed (rep by Struan Judd)
<li>form parser needs to handle aaa&bbb&cccc (rep by Eugen Kuleshov)
<li>pushBody() and popBody() should be callable outside of tags (rep by Bill Schneider)
<li>BodyContent.getString() should not clear the buffer (rep by Julie Melbin)
<li>JavaScript cast str @ String wasn't marking setUsed (rep by Alexis Liarokapis)
<li>normalize classpath in compilation (rep by Jason Collins)
<li>check for *.class existence in compilation (rep by Jason Collins)
<li>synchronization missing from ServletServer.init() (rep by Neeme Praks)
<li>session load/store wasn't properly synchronized (rep by Adalbert Wysocki)
<li>Cookies must understand quoted values (rep by Fernando Echeverria)
<li>Locking issues on NT for Apacheand IIS plugins (rep by Brian Hauer)
<li>JavaScript _first fix, allowing integers as well as doubles (rep by James Korotney)
<li>jar reloading didn't properly clear cache, causing class not found (rep by Fernando de la Villa)
<li>changes with path-mapping or absolute paths weren't detected (rep by Damien Mascorde)
<li>servlet-name=plugin_ignore in servlet-mapping causes the plugin to keep
the request for the web server (rep by Neeme Praks)
<li>added resin:include as dependency for plugins
<li>errors in resin.conf no longer cause Apache fatal errors (rep by Tauren Mills)
<li>resin:include as first element in resin.conf now picked up by plugins (rep by Neeme Praks)
<li>servlet in resin.conf now overrides servlet in web.xml (rep by Martin Cooper)
<li>added &lt;strict-mapping> tag to web-app (rep by Khang Nguyen)
<li>MemoryContext copy() needs to be recursive.
<li>Classloader cleanup to ensure loaded from top classloader
<li>Removed thread map for jdk1.2 to allow thread GC
<li>fixed XmlPrinter nullpointer (rep by tej kumar arnipalli)
<li>tag-location needs to look in classpath (rep by David King)
<li>need to propate client disconnect in RunnerRequest (rep by Casu Alain)
<li>added caucho_plugin hack to partially deal with plugin regexp issues (rep by Joan Roch)
<li>re-added accept thread blocking when accept-queue fills (rep by Dan Latham)
<li>BodyTagSupport.setPageContext needs to clear bodyContent (rep by Mikael Kjaer)
<li>resin.conf now checks resin:include for changes (rep by stefan)
<li>HttpUtils shouldn't throw IOException (rep by Peter Poulsen)
<li>Only check for Application modification on top level calls (rep by Gerret Apelt)
<li>Form processing now understands %u1234 (rep by conan)
<li>XML parsing whitespace issue with DOCTYPE (rep by Eugen Kuleshov)
<li>NT Service must open stderr.log with SHARED_WRITE for stderr log rotation to work (rep by Paul Lee)
<li>Removed img processing from stylesheets since using AWT won't work as an NT service (rep by Miles Metcalfe)
<li>early timeout of persistent sessions (rep by Gerald Francois)
<li>slowed thread closing to one per second to support more clients (rep by Dan Latham)
<li>default namespace should not affect xpath patterns in xsl stylesheets (rep by Guy McArthur)
<li>bad error message in jsp:setProperty (rep by Anthony Eden)
<li>conn.createStatement from closed pool should throw better error (rep by John Waugh)
<li>sendRedirect should kill chaining (rep by Josh Krieger)
<li>XmlPrinter wasn't handling case where location was null (rep by Frank Carver)
<li>Added upload-max for multipart-mime form uploading (rep by Cytown)
<li>jsp.StaticPage wasn't setting content-length (rep by Neeme Praks)
</ul>
</section>

<section title='1.2.1 - Dec 4, 2000'>
<ul>
<li>Caching was getting throttled because of a lock contention
<li>XSL generator wasn't escaping backslashes for setLocation and NT (rep by Frank Carver)
<li>fixed bug where a disconnected connection could cache a short file
<li>vfs.Encoding now normalizes '_' to '-' (rep by Nicolas Lehuen)
<li>fixed memory leaks in bin/resin
<li>fixed bug where the caching stream could be opened without closing
<li>ServletConfig.getInitParameter() should call getServletConfig() (rep by Steve Akers)
<li>cleaned up stream closing
<li>reworked bin/resin threading to better handle load changes
<li>added ping to detect server failures
<li>bug when caching large files and the client disconnects
<li>bug when ServerSocket.accept() received an interrupt exception, causing
Resin to hang without restart (rep by Neeme Praks)
<li>bug in looking up Resin Home for isapi registry
<li>bug with using ;jsessionid in IIS
<li>bin/resin stops in standalone mode on some OS
<li>Deleting cached file from underneath, with dual srun gives error (rep by Bill Horsman)
<li>catching throwable in TcpServer.run in case of error (rep by Neeme Praks)
<li>added bin/standalone so Windows people can get thread dumps
<li>DOM L2 changes
<li>chaining headers should match the standard headers (rep by Henrik Jensen)
<li>better detection of source close in WriteStream (rep by Bill Horsman)
<li>error-log and access-log are now per-web-app (rep by Bill Horsman)
<li>forgiving XmlParser, e.g. HTML, was misparsing CDATA (fixed! by Pieter Schoenmakers)
<li>sendRedirect needs to normalize the generated path to handle
../foo/test.jsp (rep by Stephen Wong)
<li>JndiFactoryBuilder show throw new NoInitialContextException when
an error occurs (rep by Henric Larsson)
<li>Sets the cipher-suite attribute for JSSE (rep by Derek Fukuhara)
<li>Incorrect check for jsessionid in plugings (rep by Andrew Boyko)
<li>Host: support for binary resin (rep by Piotr Piatkowski)
<li>change back to dual thread listening
<li>war change detection (rep by Jeff Trimm)
<li>http -help lists -install-as incorrectly (rep by Colin Sampaleanu)
<li>In HTML parsing, frameset should take place of body, not automatically add a body (rep by Dirk Jaeckel)
<li>init-param description should not automatically create parameter (rep by Yori Sakakura)
<li>/foo* was transformed in config.c to /fo/* (rep by Chris Chen)
<li>session attribute changes must use '==' instead of equals to detect
value change (rep by Jeremy Lemaire)
<li>forwarded and included requests are not subject to authorization (rep by Gerret Apelt)
<li>jsp:plugin params should allow runtime attributes (rep by Jean-Marc Tupin)
<li>XML Document cloneNode fixed (rep by Chris Monster)
<li>exceptions in JSP pages shouldn't be wrapped before passing to error pages (rep by Calvin Yu)
<li>User -Jxxx args need to come before other options (rep by Colin Sampaleanu)
<li>SingleThreadModel wasn't properly creating new servlets (rep by Anres Aguiar)
<li>ClientDisconnectException wasn't properly propagates in JSP (rep by Daniel Spichty)
<li>thread-timeout in resin.conf should be request-timeout (rep by Paul Lee)
<li>getServerName() was returning the remote address, not the local address (rep by Nick Popoff)
<li>Authentication caching the login and error forms (rep by Gerret Apelt)
<li>Fixed XML pretty printing with consecutive whitespace
<li>Expires not properly set with NOT_MODIFIED (rep by Dino Fancellu)
<li>symlink to empty webapp not treated as a directory (rep by Pieter Schoenmakers)
</ul>
</section>


<section title='1.2.0 - Oct 31, 2000'>
<ul>
<li>configuration changes for MacOSX and Solaris
<li>Text.setNodeValue() should be equivalent to setData() (rep by Brian Parkinson)
<li>Ring store issues with invalidate (rep by Court Demas)
<li>"resin" plugin adapted to Solaris
<li>class change detection for following classpath (rep by Frank Nestel)
<li>NT '.' issues (rep by benjurry)
<li>Cache-Control: public should override default (rep by John Moore)
<li>j_uri should override protected page (rep by Alexander Urzola)
<li>setMaxAge(0) needs to send Expires as 1994 (rep by John Moore)
<li>Apache doesn't normalize '//' in path names (rep by Henric Larsson)
<li>Fixed application nullpointer in the case of a war-dir with no web.xml (rep by David Forshlund)
<li>DBPool needs to close the underlying connection when it can't be
put back into the pool (fixed! by Chris Donnelly)
</ul>
</section>

<section title='1.2.b3 - Oct 23, 2000'>
<ul>
<li>handle absolute paths in war_dir in config.c (rep by Andy Boyko)
<li>multipart-form is now optional (rep by Manush Dodunekov)
<li>file-upload handled \n-foo wrong, and failed with nulls (rep by Stefan Wesner)
<li>ScriptClosure was using the wrong global (rep by Hans-Peter Schmidt)
<li>session ring using same storage for file backup (rep by Court Demas)
<li>License changes to Developer Source.
<li>win32 setup for O'Reilly WebSite (added! by Bob Denny)
<li>user content-length was ignored for srun requests (rep by Philippe Delrieu)
<li>bufLength vs length in HttpRequest.readRequest (rep by John Moore)
<li>errors must be logged even with an error page (rep by Chris Donnelley)
<li>XTP pages should return not found for missing pages (rep by Martyn Tovey)
<li>Changed server busy test to wait for a queue backlog (rep by Frank Nestel)
<li>form login needs to use sendRedirect, not forward() to allow https (rep by Danny Mui)
<li>Short runtime attributes "%= 2 + 2 %" weren't detected (rep by Michal Mosiewicz)
<li>Env.clear() has array overflow problems on clear (rep by John Shen)
<li>JDBC persistent store changes to remove time dependency (rep by Henry Buckley)
<li>JSP backslash not at end of line shouldn't escape (rep by Philippe Guédez)
<li>C-based launcher "resin" now available for Linux
<li>jar change detection was broken for WEB-INF/lib (rep by Frank Nestel)
<li>war-dir should be picked up by plugins (rep by Andrew Boyko)
<li>run-at timeout fixed for hour times that evaluate to 0.
<li>MergePath absolute /foo should mean top of MergePath not filesystem root (rep by Olof Edlund)
<li>findAncestorWithClass shouldn't count the tag as its own ancestor (rep by Michal Mosiewicz)
<li>304 Not Modified should not send back the MSIE hack (rep by John Moore)
<li>web-app of /test/ caused double initialization (rep by Daniel Lopez)
<li>Fix IAS issues with JNDI (rep by Russ White)
<li>changed Random load-balancing to Round-Robin
<li>Makefile fix for -with-apache-src adding memory.c (rep by Man Ly)
<li>MailtoStream fix for \n\n encoding as \r\n\r\n (fixed! by Jim Miller)
<li>added -encoding LATIN1 for Jikes to handle ISO-8859-1.
<li>xsl:exclude-namespace and xsl:namespace-alias fixed.
<li>normalize-space was printed as normalize (rep by Howard Mullings)
<li>Added SAXTransformer.
<li>SAX parser didn't properly change encoding (fixed! by Boris Granveaud)
<li>simplified the Authenticator interface and moved the session and cookies into the AbstractAuthenticator.
<li>fixed arg type to getsockopt to be compatible with alpha (rep by Roberto Ferrero)
<li>fix bugs in the access.log code (rep by Jim Douglas)
<li>use request->uri instead of request->unparsed_uri in mod_caucho (rep by Hoani Cross)
<li>XmlParser bug parsing DTD Content Particle (foo?,bar+) (rep by Abdullah Apaydin)
<li>TransactionImpl error handling fixes (rep by Robert Salesas)
<li>requests need to close the open Transaction.
<li>multiple calls to getConnection() within a transaction should return
the same connection (rep by Robert Salesas)
<li>Improved access-log rollover control (designed by Jim Douglas)
<li>Speed JavaScript import handling and fix memory reuse (Block) problem (rep by Frank Nestel)
<li>better handling of /cache deletion from under server.
<li>misc ISAPI fixes (fixed! by Bob Denny)
<li>fixed jar update problem with new classes (rep by Frank Nestel)
<li>AccessLogging with forward (rep by Jim Douglas)
<li>fixed memory leak in AbstractStylesheet (fixed! by Boris Granveaud)
<li>changed doc_header to work in different contextPaths (rep by Igor Dubosarskiy)
<li>DOCTYPE parsing can cause nullpointer when SYSTEM has unknown url (rep by MIchael Newcomb)
<li>default home fixed for IIS (rep by Dan Sandberg)
<li>Virtual hosts should automatically include port (rep by Kevin Welker)
<li>common/Makefile.in should use $(LD) instead of $(CC) (rep by Dave Wallace)
<li>JavaScript codegen change for perf enhancements.
<li>;jsessionid=aasdf;jsessionid=asdfasfd confuses sessions (rep by Spencer Marks)
<li>JNDI cleanup with url.pkgs instantiating a java: handler (rep by Russ White)
<li>JDBC persistent sessions now use update/insert instead of replace (rep by Henry Buckley)
<li>Response needs to skip() post content before sending results (rep by Khang Nguyen)
<li>DynamicClassLoader needs to synchronized on getTop() (rep by Eric Charpentier and Frank Nestel)
<li>jsp auto-compile=false turns off auto-compilation (rep by Matthew Insko)
<li>DBPool.getPool() should use java:comp/env as prefix, not java:comp/env/jdbc (rep by Russ White)
<li>sendRedirect("foo.jsp") needs to be converted to absolute (rep by Andrew Papada)
<li>alignment problems in plugins memory.c (rep by Omen Wild)
<li>"" session ids will force generation of new session (rep by Stephen Wong)
<li>jsdk22 new Cookie() was calling setPath("/") (rep by Don Choi)
<li>Jar loading performance (rep by Geoff Soutter)
<li>JSP dependencies need to be relative whenever possible (rep by Daniel Zen)
<li>&lt;srun> and srun-port configuration problems, esp with host attr (rep by Michael Forsberg)
<li>jndi: scheme for VFS
<li>Log rotation at 1Meg for all logs, including stdout/stderr (rep by Kevin Welker)
<li>LruCache put() needs to call removeEvent when the old value is replaced.
<li>external DTD syntax was completely wrong (rep by James Dalrymple)
<li>multipart-form boundary header fix
<li>SmtpStream needs \r\n for newlines (fixed! by Daniel Zen)
<li>j_uri in form login should allow relative urls (rep by Dave Gochfeld)
</ul>
</section>

<section title='1.1.5 - Oct 2, 2000'>
<ul>
<li>For version 1 cookies, omit the Expires parameter (rep by John Moore)
<li>missing is.close() in Xsl for strict stylesheets (rep by David Soergel) 
<li>Change reporting forward() with committed data (rep by 
<li>XPath substring() is 1-based, not 0-based. (rep by Nicolas Lehuen)
<li>mod_caucho and TcpServer changes to enhance reliability under load
<li>nested bodyTag problems with the end-tag-hack (rep by Veronique Dupierris)
<li>jsp:param value="" name=foo was thrown as illegal (rep by Jacek Laskowski)
<li>Using String[] for a tag variable was failing (rep by Fernando Olcoz)
<li>PageContext needs getThrowable() (rep by Ari Halberstadt)
</ul>
</section>

<section title='1.2.b2 - Aug 31, 2000'>
<ul>
<li>cache synchronization fix
<li>war expansion fix (patch! by Vitaly Batychko)
<li>JSP lineMap and depends should be app-dir relative (rep by Matthew Insko)
<li>jndi.properties should be configured in resin.conf (rep by Russ White)
<li>allow String[] in taglib
<li>create ResinServer.init() and ResinServer.close() (rep by Rick Gibbs)
<li>SingleThreadModel
<li>Using CauchoSystem.loadClass in SessionStore for some finicky class loaders (rep by Dave Wallace)
<li>keepalives were closing prematurely (rep by Horst Reiterer)
<li>made QPooledConnection.getConnection() public (rep by Mark Dobbrow)
<li>POST forms need to work with forward even if content-type is form (rep by Jason Martino)
<li>Use XmlParser.QAttributes in ContentHandlerAdapter (rep by Frank Nestel)
<li>jndi.properties in WEB-INF/classes overrides InitialContext (rep by TH Lim)
<li>jndi-link fix to work with WebLogic
<li>reversed classloader order to match JDK 1.2
<li>xsl:attribute needs to override attributes (rep by Steve Chiu)
<li>TagSupport.getValues() should return the keys (rep by Calvin Yu)
<li>XML/XSL now parses and prints strings (rep by James Brosnan)
<li>Fixing command-line invocation, httpd -e, jspc
<li>detect win2k utf-8 with 0xfeff (rep by Jun J. Kang)
<li>use application classloader for persistent sessions (rep by Dave Wallace)
<li>RunnerRequest needs to call filterRead.close() instead of flush
<li>when hit thread-max, start sending 503, Server Busy Errors (rep by John Moore)
<li>XmlParser was calling endElement for the document (rep by Martin Cooper)
<li>VirtualHost needs to add app to map before calling init (rep by Martin Cooper)
<li>jspInit() called an extra time when modified (rep by Marcin Jagodzinski)
<li>init(config) now works in JSP, though you should use jspInit() rep by Felix von Delius)
<li>XTP now uses servlet parameters (rep by Marcin Jagodzinski)
<li>&lt;iis priority> configuration for ISAPI priority (rep by Martin Cooper)
<li>Strip '"' from CLASSPATH (rep by Colin Barrett)
<li>JNI now disabled by default
<li>Document.getOwnerDocument() should return null (rep by Nicolas Lehuen)
<li>NT stdout/stderr logs redirected to log/stdout.log (rep by James Dalrymple)
<li>IIS double decode of servlet path fixed (rep by Jason Collins)
<li>XSL API rewrite using factory patterns to resemble XSL engines
<li>JavaScript API rewrite to user factory patterns
<li>script notation in XSLT-lite, $if, $while, etc.
<li>strip leading 0xfeff from utf-8
<li>HTML/XML parser now optionally parses comments (rep by Eric Hansen)
<li>quotes inside runtime attributes now work
<li>DBPool max-idle-time -1 means infinite (rep by Steve Buikhuizen)
<li>JspWriter.getRemaining() was always returning 0 (rep by Felix von Delius)
<li>session interval of -1 should be infinite (rep by Vince Callaway)
<li>report load-on-startup error pages to browser
<li>caching synchronization fix
<li>jdbc-store can now configure the tables (rep by Vince Callaway)
<li>caucho-status shows timeouts, fix timeout config (rep by Kevin Welker)
<li>added jndi-link supporting InitialContextFactory (rep by Fredrik Gustavsson)
<li>Filled out JNDI implementation
<li>httpd-port/srun-port deprecated
<li>SSL support with JSSE
<li>security-provider in config
<li>system-property in config
<li>dom level2 core support
<li>sax2 support
<li>jaxp support
<li>XML external entity support
<li>httpd/srun.exe resin-home search order
<li>httpd/srun.exe -java_exe and -Xxxx
<li>multipart-form/data
<li>taglib uri-location should look for jars in classpath (req by Matthew Faso)
<li>'\' escape at end of line after %> will escape end of line (added by Talin)
<li>config.c fix to handle null host 
<li>DBPool now has setMaxIdleTime (max-idle-time) for max idle time (rep by Kesav Kumar)
<li>auto-compile classes in multiple &lt;classpath> can now use any class (rep by Nick Popoff)
<li>adding overriding xsl should cause xtp reload (rep by Ralph Winzinger)
<li>localization mechanism added and message_en.xml added for JSP
<li>fixed plugin bug forcing configuration reload every 15 seconds
<li>plugins now use memory pooling to avoid leaks when rereading configs
<li>better error reporting for errors in init()
<li>improved detection of web.xml changes in plugins
<li>&lt;jsp require-source=true> will now give an error when the JSP is deleted (rep by Phil Smy)
<li>XmlPrinter now understands OutputStream and Writers (rep by Jim Brosnan)
<li>httpd-Mac was missing from distribution
<li>ejb-ref now available with custom client factories
<li>jndi configuration can now also appear in global configuration
<li>UserTransaction support in DBPool
<li>DBPool configuration now allows arbitrary properties (impl! by Tatsuya Bizenn)
<li>better error message for bind exceptions (rep by Donald Vandenbeld)
<li>Alarm and Cron missing from ServletServer! (rep by Donald Vandenbeld)
<li>throw NullPointerException from sendRedirect (rep by Marc Larue)
<li>caucho.xsl.stylesheet fix for reloading (fixed! by Talin)
<li>session-config/cookie-domain to better support multiple hosts (req by HyoungKi Choi)
<li>dbpool fix for problem preventing any pooling
<li>parse error printing didn't work with plugins
<li>Content-Length available() incorrect (rep by Dave Moellenhoff)
<li>handle long urls (rep by Melanie Lampert)
<li>detect duplicate servlet definition (rep by Richie Bielak)
<li>make url-pattern case sensitivity configurable (req by Eugene Jhong)
<li>external dtd in xml files (req by Steve Chiu)
<li>use *.class even if the *.jsp is gone (req by Jens Gerhard and Frank Nestel)
</ul>
</section>

<section title='1.1.4 - Sep 6, 2000'>
<ul>
<li>nullpointer in all plugins for certain resin.conf (rep by Ed Miner)
<li>caucho-status was not allowed in resin.conf (rep by Tauren Mills)
<li>Base64 decoding fix (rep by flare)
<li>"listen" is an allowed configuration in the server (fixed! by Jim Douglas)
<li>getRemoteUser with IIS/Apache, but unconfigured should return basic principal (rep by Andre Minelli)
<li>resin:include with file-not-found was adding resin:include as node (rep by Gregg Carrier)
<li>Fix ;jsessionid on IIS (rep by Jens Goring)
<li>Fix -encoding for external javac (rep by YT Kim)
<li>Fix Apache getRemoteHost() (rep by Horst Reiterer)
<li>TagSupport.getValues() should return the keys (rep by Calvin Yu)
<li>IIS double decode of servlet path fixed (rep by Jason Collins)
<li>call nextWrite.close() instead of nextWrite.flush() in ServletFilter.close()
<li>mime-mapping expected .foo instead of foo (rep by Alain Origlia)
<li>fixed string-length() toString() in XPath (rep by Nicolas Lehuen)
<li>removed +CSO from jikes compilation (rep by Court Demas)
<li>circular include detection bumped up to 64 (rep by Yori Sakakura)
<li>JSP files for host:8080 were aliased with host:8090 (rep by David Thomas)
<li>trailing space in filename was causing problems under NT (rep by Thomas Weber)
<li>QRequestDispatcher race between request recycling and flushing (rep by Floyd Marinescu)
<li>recover when cache file deleted underneath request (rep by Tim Fox)
<li>cookie expires date was formatted wrong (rep by Dan)
<li>configure.in fixes for iPlanet (rep by Michael Los)
<li>jsp/end-tag-hack to work around tag library bugs (rep by Tim Fox)
<li>XslGenerator.generate needs synchronization (rep by James Brosnan)
<li>XPath sum() wasn't properly printed in XSL (rep by Marcin Jagodzinski)
<li>configuration period has int/long overflow for month/year (rep by Rob Snell)
<li>using BodyContent after dead should throw IllegalStateException (rep by MichalMosiewisz)
<li>workaround for IE hiding error messages by default (rep by Tiberiu Fustos)
<li>setSoTimeout is now configurable
<li>cookies and sessions use Cache-Control: private for HTTP/1.1 and nothing for HTTP/1.0
<li>anonymous caching uses Cache-Control: x-anonymous
<li>explicit header should override cookie expires (rep by John Moore)
<li>JSP preload with errors not properly caught (rep by Marc Larue)
<li>content-length now recognized (rep by Julie Melbin)
<li>cse_write_packet must be able to write empty packets
<li>&lt;jsp_plugin can't have space in '; version' (rep by Jeff Perry)
<li>MemoryStream bug causing array exception (rep by Lukasz Kowalczyk)
<li>tweaks to class-update-interval as used by JSP pages
<li>Fixed synch problem in QNamedNodeMap (rep by Brian Parkinson)
<li>srun-port not picked up by mod_caucho (rep by Carlos Hanson)
</ul>
</section>

<section title='1.1.3 - June 23, 2000'>
<ul>
<li>handling of "out" in JSP files (rep by Dirksen Lau)
<li>nullpointer in javascript when reload on server restart (rep by Piotr Fernandez)
<li>app-dir/web.xml not detected by plugins (rep by Alexander Jerusalem)
<li>// %> was causing problems (rep by Matthew Faso)
<li>iis_srun extension forwarding all req to Resin (rep by Filip Salomonsson)
<li>large headers truncated with IIS (rep by Melanie Lampert)
<li>thread-max calculation broken (rep by Matthias Ernst)
<li>added disable-content-length (rep by Rafi Jacoby)
<li>problems handling ';' in url (rep by Stefan Podkowinski and Vitaly Batychko)
<li>missing host always returns the default host (rep by Antonio Freixas)
<li>getRequestURI should return unescaped uri (rep by Mattias Ernst)
<li>session.setAttribute can cause unboundEvent (rep by Oliver Koell)
<li>form spaces not handled properly (rep by George Diswani)
<li>&lt;a> can't be pretty-printed (rep by Eric Hansen)
<li>test.jsp not always force make of &lt;classpath> (rep by Scott Douglass)
<li>log(Exception) needs to unwrap exceptions (rep by Christian Wehrfritz)
<li>cookie parsing wasn't catching 'foo=bar,baz=19' (rep by Jens Dennig)
<li>some clients can send 'max-age' as cookie name (rep by Tripp Lilley)
<li>jsp:useBean needs to understand import and inner class (rep by Matthew Faso)
<li>ip printing writing signed bytes (rep by Ringer9)
<li>error-page 500 should catch servlet errors (rep by Dave King)
<li>request dispatcher include should allow spaces in query (rep by omar)
<li>jsp:getProperty must use pageContext.findAttribute
<li>BodyTag variables must use pageContext.findAttribute
<li>BodyTag threading issues (rep by Matthew Faso)
<li>Servlet ambiguity in JSP generation (rep by Rolf Scherer)
<li>mod_caucho issues with slow servers.  Also added configuration in srun. (rep by Tiberiu Fustos)
<li>&lt;java args='-O'> didn't work for jikes (rep by Alan Berezin)
<li>xsl:if for not(node()) was throwing RuntimeException (rep by Stargazer and Marcin Jagodzinski)
<li>JSP generation should use full class names (rep by Rolf Scherer)
<li>jikes detection fails for c:\foo\jikes.exe (rep by James Korotney)
<li>fix for -srun argument (rep by Antoine Baudoin)
<li>pretty-printing fix for &lt;img> (rep by Steve Chiu)
<li>xpath substring-after bug (rep by Steve Chiu)
<li>improved mod_caucho connection heuristics
<li>added socket timeouts
<li>HttpServer should use 127.0.0.1 instead of localhost (rep by Neuronix)
<li>load-on-startup with jsp-file (rep by Robert Grzywinski)
<li>jsp:getProperty needs to understand isFoo (rep by Nasir Akhtar)
<li>.war files need to handle .jsp (rep by Frank Nestel)
<li>&lt;% %> shouldn't automatically generate ';' (rep by Steve Chiu)
<li>Use QJspFactory to avoid conflict with epicentric (rep by Tripp Lilley)
<li>Report a better message for EPIPE (rep by Tripp Lilley)
</ul>
</section>

<section title='1.2.b1 - June 15, 2000'>
<ul>
<li>env-entry naming fix
<li>basic log rotation
<li>threading fix to handle thread pool better
<li>DOM level 2 stubs for Xalan compatibility
<li>CompilingClassLoader shouldn't mkdir WEB-INF/classes (rep by Scott Douglass)
<li>DBPool pinging to detect crashes sessions (suggested by Guy Tal)
<li>session reload attribute so each session request refreshes itself
<li>distributed sessions with JDBC
<li>DataSource configuration
<li>support for JNDI java:comp
<li>invocationKey needs getHost() instead of host (rep by Paul Little)
<li>setContentLength no longer ignored (rep by Xavier Boix)
<li>jsp:directive/declaration/scriptlet treated as globals in XTP (req by Eric Hansen)
<li>Mac lexing issues with \r (rep by Paul Snively)
<li>LogStream must only open each file once for Mac (rep by David Smiley)
<li>threading rewrite for performance and stability
<li>directory uses application char encoding (rep by Jen Hsien Huang)
<li>cleaned main request/service() path
<li>added basic implementation of distributed sessions
<li>faster detection of connection failures (rep by Tomas Lund)
<li>significant performance improvements for small files.
<li>anonymous caching can now ignore user tracking cookies
<li>new configure and Makefiles, and support for --with-apache-src.
<li>created SessionManager and added file-based persistent sessions
<li>plugins now detect resin.conf changes automatically
<li>access-log can now log cookies with %{JESSIONID}c
</ul>
</section>

<section title='1.1.2 - May 19, 2000'>
<ul>
<li>fix dup loading load-on-startup when host='' (rep by Jan Ploski)
<li>caucho.jsp-file wasn't properly deleted in some cases (rep by Robert L. Grzywinski)
<li>Threading issue where keepalive counts never dropped.
<li>Threading issue where all threads could exit simultaneously (rep by Elad Koren)
<li>On NT, cookie sessions for load balancing weren't sticky
<li>On NT, setup remove removes all filters (rep by Helen Grimbly)
<li>WAP has trouble with '.' as session character (rep by Ole Dalgaard)
<li>All Authenticator methods now take HttpServletRequest
<li>Check modification with '!=' instead of '<' for JSP (rep by Paul Snively)
<li>Caching wasn't removing files when LRU kicks in (rep by Ed Miner)
<li>fix in URL normalization (rep by mark)
<li>wrapper.pl cleanup (rep by Kevin Welker)
<li>resin.form.locale (req by Avi Cherry)
<li>mod_ssl variables (req by Jens Dennig)
<li>xsl:attribute has trouble in macros (rep by Steve Chiu)
<li>cookie values should not be restricted to 256 bytes (rep by Roberto Tiella)
<li>jspDestroy should be called on JSP change (rep by Den Riabtchik)
<li>resin:include of 'c:\foo' doesn't work on NT (rep by Ken Koster)
<li>cache-mapping 40d overflows RegistryNode.getPeriod() (rep by Jerry Huxtable)
<li>"meta-inf/taglib.tld" error not caught in tag.jar (rep by Juraj Kazda)
<li>"extends" now checks for HttpJspPage (rep by Ed Miner)
<li>line number mapping for thrown exceptions
<li>logging should be in local, not GMT (rep by Carlos Hanson)
<li>run-at executing at :00 and :01 (rep by Daniel Seltzer)
<li>run-at should use dummy HttpServletRequest (rep by Daniel Seltzer)
<li>Cookie parsing should handle Cookie: foo; bar; (rep by Kien Kiong Ng)
<li>web-app encoding should override response encoding for forms (rep by Vyacheslav Pedak)
</ul>
</section>

<section title='1.1.1 - April 27, 2000'>
<ul>
<li>xsl:include doesn't obey strict-xsl (rep by Steve Chiu)
<li>JavaScript can't handle java.lang.System.out.writeln (rep by Charlie Evett)
<li>DirectoryServlet needs fix for web-app (rep by Daniel Seltzer)
<li>PageContext must implement pushBody and popBody (rep by Tripp Lilley)
<li>ResponseAdapter needs buffering for locomotive (rep by Leo Deegan and Ari Chopra)
<li>Authenticator should allow request (rep by Paul Snively)
<li>FormLoginServlet should use redirect instead of forward (rep by Francois Rene Bertrand)
<li>session.invalidate() should generate new id (rep by Jens Dennig)
<li>&lt;%@ page extends means the page isn't static (rep by Eugen Kuleshov)
<li>beanName with RTA should use getClass not GetClass
<li>caching issues with include pages (rep by Ed Miner)
<li>JavaScript generating too-large methods (rep by Charlie Evett)
<li>web-app id="/" treated different from default web-app (rep by Jeff Behl)
<li>caching broken with large files (rep by Ed Miner)
<li>foo.jsp\ shows the source on NT (rep by James Griggs)
<li>'/' should dispatch everything to Resin (rep by Nick Popoff)
<li>mixed context in resin.conf should be caught (rep by Eric Hansen)
<li>bad elements in http-server should be caught (rep by Ed Miner)
<li>foo.jsp\ will show foo.jsp on NT (rep by James Griggs)
<li>xsl:param at top level isn't recognized (rep by Steve Chiu)
<li>jsp:root (rep by Steve Chiu)
<li>bad generation of "implements SingleThreadModel" (rep by David Malkovsky)
<li>TagAttributeInfo constructor API mixed up (rep by Victor Salaman)
<li>TagData(Object []) constructor broken (rep by Victor Salaman)
</ul>
</section>

<section title='1.1.0 - April 8, 2000'>
<ul>
<li>forward() should just clearBuffer(), not reset() (rep by Alex Cruikshank)
<li>Long variables not handled properly in tags (rep by Robert Grzywinski)
<li>setStatus shouldn't send error or load cache (rep by Daniel Lopez)
<li>load-on-init problems with web-app (rep by Daniel Seltzer)
<li>"%= ... %" is an allowed request time expression (rep by Mark Hayes)
<li>DirectoryServlet should work like FileServlet (rep by Alex Cruise)
<li>extends JSP files need to detect changes (rep by Dmitry Maximovich)
<li>Cron needs its own thread and needs to eliminate sync (rep by Victor Salaman)
<li>make sure caching files get closed even if servlet fails (rep by Sonny Pickett)
<li>BodyTag.getPreviousOut should return out even at top level (rep by Chris Martin)
<li>resin.conf and web.xml should be combined (rep by Ari Halberstadt)
<li>fixed large jsp file bug (rep by Chris Burnley)
<li>remove duplicate entries from mod_caucho (rep by Henric Larsson)
<li>&lt;cache size=0> should disable the cache (rep by Alex Chung)
<li>iis_srun.dll fixing logs (rep by David Seltzer)
<li>Form handling bug: foo=&bar=15 fails for foo (rep by Henric Larsson)
<li>Vary: Cookie -- cookie pages are now cacheable for non-logged in users.
<li>sessions should survive forward() (rep by Dalton Iwazaki)
<li>mod_caucho issues with error-page (rep by Borne Mace)
<li>Added caucho-status=false directive (rep by Daniel Seltzer)
<li>Added compile=false directive (rep by Arnick Hahn)
<li>JSP attributes should be javax.servlet.jsp.jspException (rep by Jeff Behl)
<li>getElementsByTagName should never return null (rep by Chris Chen)
<li>forwarded pages should have access to Post input stream (rep by Michal Mosiewicz)
<li>shortest should match dual *.go and *.jsp match (rep by Jeff Behl)
<li>renamed port -> httpd-port to reduce confusion
<li>&lt;!DOCTYPE parsing not handled by plugin (rep by Marko Asplund)
</ul>
</section>

<section title='1.1.b6 - March 20, 2000'>
<ul>
<li>XslFilter should use page parent as pwd (fixed! by Chris Chen)
<li>JSP generator needs to use booleanValue instead of boolValue (rep by Rob Grzywinski)
<li>NT setup of Apache httpd.conf needs to escape backslashes (rep by Phil Smy)
<li>getRequestedSessionId() should return the ID even if the session is new (rep by Stan Silvert)
<li>Host logs should be in RESIN_HOME/log (rep by John Cyriac)
<li>JS wrapped methods where an arg is private aren't allowed (rep by Chad Hamann)
<li>empty JSP tags should still evaluate the methods (rep by Sergio Soccaras)
<li>XSL should use consistent 'node' and 'inputNode' in xsl:for-each (rep by Michal Mosiewicz)
<li>XSL document() must be a cache-depends (rep by Michal Mosiewicz)
<li>added thread-keepalive attribute
<li>JavaScript bean wrapper should look at BeanInfo (rep by Vamsee Lakamsani) 
<li>NSAPI wasn't handling HTTP/0.9 properly (rep by Rich Farrell)
<li>FileServlet should work with servlet-mapping (rep by Alex Cruise)
<li>ISAPI HTTP_FOO_BAR needs to convert to foo-bar (rep by Paul Sheehan)
<li>mod_caucho would match /servletxxx for /servlet/* patterns (fixed! by Robson Miranda)
<li>autoreload of web.xml and resin.conf should be more robust with errors (rep by Larry Hamel)
<li>JSDK/JSP API fixes for Visual Age (debugged! by Robert Salesas)
<li>Default server root should be resin.home (rep by Robert Salesas)
<li>Jar caching (impl! by Victor Salaman)
<li>forward() reset and finish (rep by Michal Mosiewicz)
<li>JSP exceptions should be thrown instead of caught (rep by Nick Popoff)
<li>load-on-startup problems with different config (rep by Marco Hunsicker)
<li>windows-125x character encoding (rep by Eugen Krivoruchko)
<li>&lt;jsp session=false> disables sessions by default (rep by Rafi Jacoby)
<li>CauchoRequest.resetTimeout() and reset timeout on activity (rep by Dave Moellenhoff)
<li>Multiple -J-mx were getting swallowed by wrapper.pl (rep by Bill Carroll)
<li>Missing &lt;%@ include %> should work with errorPage (rep by Ed Miner)
<li>UnionPattern fixes for XSL (rep by Michal Mosiewicz)
<li>reading of Certificates with mod_ssl (rep by Marko Asplund)
<li>Set-Cookie conformance to RFC2109 (rep by Ken Yun and Niranjan Nagar)
<li>jsp-file as servlet fixes (rep by Slawek Zachcial)
<li>omit-html-declaration and only minimize html booleans (rep by Michal Mosiewicz)
<li>mod_caucho can now distinguish between ports (rep by Robert Grzywinski)
<li>fix to plugin resin.conf parsing and handling of web-app id='/foo' (rep by Slawek Zachcial)
<li>wrapper.pl needs to pick up zip (rep by Jeff Haynie)
<li>cleanup ./configure and install.sh
<li>host app-dir should be relative to http-server (rep by Paul Snively)
<li>Support for NT UNC (\\host) (rep by Mark Rowell)
<li>HTTP/1.1 chunked encoding problems (rep by Seth Ladd)
<li>position() in xsl:if (rep by Seth Ladd)
<li>ClassLoader fixes for loading jni (rep by Pierre Dony)
<li>-install-as and -remove-as for NT services (submit! by Alan Douglas)
<li>user-name and group-name added to avoid running as root (rep by Nir-Tzion)
<li>files need escaping in JavaGenerator (rep by Naresh Sikha)
<li>sesson and load statistics in "caucho.statistics" (req by Mattias Nilsson)
<li>browser-mapping lets Resin handle broken http clients (rep by Kevin Minder)
<li>DBPool now implements java.sql.Driver (contrib! by Kevin Minder)
<li>tag.release() should have access to pageContext (rep by David Geary)
<li>classpath with no source shouldn't autocompile (rep by Edson Richter)
<li>xsl:for-each needs to set the list-context (rep by Seth Ladd)
<li>Application class loader is a "caucho.class-loader" attribute (rep by Vladimir Zamiatin)
<li>added lots of default mime mappings.
<li>JSP/XTP precompiled pages avoid parsing
<li>timestamp in logs should be local (rep by Scott Douglass)
<li>xsl can (and should?) be put in the class path
<li>XTP/XSL line numbers are now reported better
<li>&lt;%= 2 %> as default XTP text should not be escaped.
<li>wrapper.pl should use socket constants (fix! by Dave Moellenhoff)
<li>handle DBPool overflow by waiting instead of throwing an exception.
<li>work-dir fix (rep by everybody)
<li>servlet.init() calling of getRealPath doesn't work (rep by Eric-Olivier Lamey)
<li>jsp:setProperty with String[] should use getParameterValues (rep by Karsten Merkle)
<li>tag optional initialization of Object property should use null (rep by David Geary)
<li>POST errorPage to file returns method not implemented (rep by Alik Eliashberg)
<li>i18n in nested body tag (rep by Michal Mosiewicz)
<li>completed &lt;run-at> servlet option
<li>RunnerResponse problems flushing from forwarded page (rep by Ed Miner)
<li>completed &lt;cache-mapping>
<li>basic auth now goes through authenticator (rep by Michal Mosiewicz)
<li>servlet matching is now case-insensitive on NT
<li>regexp hosts: &lt;host regexp='(?:[^.]+.)?([^.]+).com'>
<li>setContextClassLoader for servlet.init (rep by Rich Roth)
<li>httpd.exe now uses console mode (rep by Mac Chan)
<li>XTP needs to set Last-Modified properly (rep by Hans-Peter Schmidt)
<li>DBPool robustness for failed connections (suggested by Michal Mosiewicz)
<li>httpd.exe causing jdbc.odbc errors (rep by Paul Bauersfeld)
<li>DBPool.getActiveConnections (rep by John Zedlewski)
<li>filtering doesn't preserve encoding (rep by Michal Mosiewicz)
<li>/script/iis_srun.dll appears in URL
<li>JavaScript name mangling can't use base64 (rep Paul Bauersfeld)
<li>unset tag attributes and values must be cleared for reused tags (rep Avi Cherry)
<li>taglib uri='foo.jar' should look for META-INF/taglib.tld (rep by Sergio Socarras)
<li>&lt;error-page> in http-server (Apache only) (req by Eric Hansen)
<li>resin:include (req by Eric Hansen)
<li>wrapper.pl needs setpgid (rep by Das Ashutosh)
<li>plugins need to understand web.xml (rep by Zachcial Slawek)
<li>caching deletes charset from headers (rep by Michal Mosiewicz)
<li>file not found from forward should be handled normally (rep by Ed Miner)
<li>node()|@id matches all attributes (rep by Michal Mosiewicz)
<li>Form processing with extra '&' (fixed! by Steve Abatangle)
<li>request.getRequestDispatcher problems with contextPath (rep by David Soergel)
<li>mod_caucho handling multiple hosts in &lt;host> (rep by Zach Bagnall)
<li>Rewrite of JavaScript code generation and bean wrapping.
<li>httpd -e &lt;url> statically executes the url (req by Ed Miner)
<li>foo.jsp. on NT shows the source of foo.jsp! (rep by Sassan)
<li>ServletServer now grabs ContextClassLoader and allows pseudo-global &lt;classpath>
<li>jsp:include in BodyTags (rep by Ilan Kirsh)
<li>Improved performance for jsp:include, and jsp static pages (rep by Ed Miner)
<li>Fixes for wrapper.pl heuristics finding RESIN_HOME (fixed! by Victor Salaman)
<li>-deadwait fixes using socket instead of System.read.in (rep by Victor Salaman)
<li>CLASSPATH, JAVA_HOME, RESIN_HOME now saved in NT service (rep by Eitle Jurgen)
<li>-J, -D now handled by NT (rep by Niel Esary)
<li>Session id should not use '/' (rep by James Kao)
<li>Nested TagBody tags not properly resetting out (rep by Ilan Kirsh)
<li>\r issues in JSP and XTP parsing causing problems with Mac (rep by David Smiley)
<li>Vfs/Path cleanup (reviewed! by David Smiley)
<li>DBpool cleanup (reviewed! by Matthew Young)
<li>created webutil.HttpForm (req by Paul Snively)
</ul>
</section>

<section title='1.1.b5 - January 17, 2000'>
<ul>
<li>SimpleClassLoader not putting jars in class loader (rep by Daniel Lopez)
<li>DirectoryClassLoader not putting jars in class loader (rep by Victor Salaman)
<li>Taglib tld lookup in jar file, i.e. app.getResourceAsStream looks in class loaders (rep by Paul Lacrosse)
<li>-Dfoo=bar and -J-mx=z support in wrapper.pl (fixed! by Len Maxwell)
<li>Threading control now handles keepalives better
<li>NSAPI setup on NT
<li>NT problem with trailing slash for Resin-home (rep by Moshe Yidgar)
<li>-nojit not work with NT (rep by Jonathan Goldstein)
<li>TagBodySupport must throw TagException (rep by David Geary)
<li>@&lt;&lt;END fails on NT (rep by Paul Snively)
<li>BodyContent not handing i18n properly (rep by Avi Cherry)
<li>sendError and sendRedirect should close Response (rep by Mark Feldhousen)
<li>jar, http, tcp getAvailable() implemented (rep by David Soergel)
<li>getParameter uses response.getCharEncoding (rep by Slawek Zachcial)
<li>JSP tag variables need indirection (rep by Ilan Kirsh)
<li>Application class loaders combined into one (rep by Ilan Kirsh)
<li>simplified JSP error formatting (rep by Rich Roth)
<li>iis_srun.dll supports caucho-status, setup.exe more robust
<li>Xml parsers now inherit XmlParser to look more SAX-like
<li>XSL stylesheet precompilation problems fixed.
<li>Xtp printing now changed to use xsl:output (rep by Mical Mosiewicz)
<li>getAttribute now works on a http: vfs stream (rep by Paul Snively)
<li>XML parsing now using internal utf8 reader (rep by Victor Salaman)
<li>preceding-sibling:: and following-sibling:: fail in filters (rep by Paul Snively)
<li>&lt;classpath> now grabs character-encoding for i18n (rep by kempleo)
<li>&lt;classpath> and &lt;java> now allow "args" (rep by Avi Cherry)
<li>Servlet 2.2 complete except for client certificates!
<li>HttpServer now accepts -srun to select the srun (rep by Herve Boutemy)
<li>ServletContext.getMinorVersion should be 2 (rep by David Smiley)
<li>Timeouts never called (rep by Emmanuel Blot and Jan Epsen Hansen)
<li>non-ascii URLs with mod_caucho didn't work (rep by Christian Thomas)
<li>Win98/PWS changes to setup.exe
<li>JSP tags and servlet interaction (scope issues) (rep by Avi Cherry)
<li>JSP tag library tld lookup incorrect (rep by Sergio Socarras)
<li>JSP precompilation wasn't working (rep by David Smiley)
<li>Element.getAttribute should return "" if attribute missing (rep by David Smiley)
<li>Microsoft JVM now supported
<li>Supporting Java arguments on win32 with -J&lt;arg>
<li>iis_srun and mod_caucho fixes for short writes to browser (rep by Michael Burks)
<li>httpd.exe and srun.exe are now graphical.
<li>The configuration and compilation for Unix changes to configure/make
<li>NSAPI for Unix is now included!
<li>install.sh problem test ! grep is bogus (rep by Chris Cobb)
<li>forward needs to use the old query string (rep by Erich Bratton)
<li>HttpStream should set Host: xml.com, not Host: xml.com:80 (rep by Alex Chaffee)
<li>iis_srun fixes for large files (rep by Emmanuel Blot)
<li>PageManager fixes for Jetty (rep by James Korotney)
<li>Html parser (XTP) lowercased non-html tags (rep by James Kao)
<li>jsdk22.jar didn't make parseQueryString public (rep by Court Demas)
<li>-conf foo.conf should look in resin_home, not resin_home/conf (rep by Court Demas)
<li>IIS and Apache both support load balancing and keepalives
<li>mod_caucho didn't handle /servlet/* properly (rep by Jeremiah Thompson)
<li>'<' XTP attributes were printed as <.  Also, disable-output-escaping wasn't affecting attributes (rep by Michal Mosiewicz)
<li>self::node() not interpreted as axis in XPath expression (rep by Paul Snively)
<li>Added apache-1.3.4 mod_caucho.dll to distribution
<li>Path info now handled by mod_caucho and iis_srun (rep by Michal Mosiewicz)
</ul>
</section>

<section title='1.0snap - December 6, 1999'>
<ul>
<li>If FooPage extends JavaPage, it should print LineMap (rep by HyoungKi Choi)
<li>ApplicationAdapter fixes for Jetty (rep by James Korotney)
<li>TcpServer backpatched from 1.1 (rep by Emmanuel Blot)
<li>XtpPage handling i18n
</ul>
</section>

<section title='1.1.b4 - December 3, 1999'>
<ul>
<li>C memory overrun problems causing dispatching trouble in mod_caucho and iis_srun (rep by practically everybody)
<li>form char-encoding can now be controlled by Request attribute
"resin.form.character.encoding" (Avi Cherry)
<li>Commented out experimental caucho-status CPU usage
<li>XTP i18n problems with ISO-8859-2 (rep by Michal Mosiewicz)
<li>NT services now grab command lines (rep by Julien de Murcia)
<li>HttpStream can now set headers (rep by Paul Bauersfield)
<li>XSL support now follows the 16 Nov spec.
<li>wrapper.pl improvements to -verbose (by Emmanuel Blot)
<li>web-app id='/foo/' confuses getRequestDispatcher (rep by Dave Smiley)
<li>application.getRequestDispatcher("foo.html") in web-app 'bar' looks at
barfoo.html. (rep by Dave Smiley)
<li>Env.java now is a GenericServlet (rep by Dave Smiley)
<li>getServerName was returning foo:8080 (rep by Dave Smiley)
<li>load balancing mixup with session ids (rep by Mattias Nilsson)
<li>jspDestroy never called in JSP (rep by HyoungKi Choi)
<li>setup.exe now available on NT
<li>&lt;a href=a/b> not handled by HTML parser (rep by Paul Bauersfield)
<li>Added LooseHtml for parsing net documents
<li>ECMAScript now allows users to define null and undefined mappings for
Java (rep by Mark Addleman)
<li>-conf not using lookupNative on NT (rep by Julien de Murcia)
</ul>
</section>

<section title='1.0.2 - November 17, 1999'>
<ul>
<li>sessions encoded in query for wap (rep by Osma Ahvenlampi)
<li>mod_caucho wasn't sending auth
<li>NativeDate needs sync with QDate (rep by Mark Addleman)
<li>Session invalidation throws Concurrent exception (rep by David Smiley)
<li>StaticGenerator used lookup instead of nativeLookup (rep by David Smiley)
<li>Java JSP generation expected more than HttpJspPage (rep by David Smiley)
</ul>
</section>

<section title='1.1.b3 - November 16, 1999'>
<ul>
<li>First cut at JSP 1.1 tag extensions
<li>Minor cleanup of shutdown protocol
<li>mod_caucho flushing cleanup and ResponseStream close (rep by Mattias Nilsson)
<li>XmlUtil.getPIAttribute robustness (fixed! by David Smiley)
<li>several JSP and bean recompile bugs (rep by Mattias Nilsson)
<li>mod_caucho was only scanning first cookie for load balancing (rep by Mattias Nilsson)
<li>class problems using jikes as external parser
<li>license changes to open source
<li>JavaScript code generation fixes to make JDK 1.2 happy.
<li>Fixed some issues relating to using jikes as an external parser
<li>IIS dispatch of servlets with query strings (rep by Stephen Owens)
</ul>
</section>

<section title='1.1.b2 - November 4, 1999'>
<ul>
<li>'Proxy' caching added
<li>Servlet chaining now works with jsp:include.
<li>First cut of a Resin load status
<li>Backed out Java JSP string optimization.
<li>Catching EINTR in mod_caucho
<li>Added CauchoErrorPage to mod_caucho (rep by Niranjan Nagar)
<li>Infinite jsp:include loops are now detected (rep by Camille Riddle)
<li>mod_caucho now works nicely with Apache (rep by Niranjan Nagar)
<li>Cookie age has 32 bit bug
<li>Session synch issues
<li>Pages returned for the wrong url (rep by Mattias Nilsson and Camille Riddle)
<li>getBufferSize() not handed in jsdk2.1 (rep by Mattias Nilsson)
<li>jsdk22.jar not handle readline properly. (rep by Mattias Nilsson)
<li>included files have proper character encoding (Primoz Hrvatin)
<li>XtpFilter -> XslFilter and fixing XtpFilter problems (Franck Rasolo)
<li>mod_caucho squashed multiple cookies (Camille Riddle)
<li>configuration files now live in resin/conf (Emmanuel Blot)
<li>added first cut at a Resin tutorial
<li>servlet-mapping now understands '/' (Slawek Zachcial)
<li>path-mapping now understands regexps (Emmanuel Blot)
<li>more threading tweaks in TcpServer
<li>fix threadDeath deadlock (rep by Camille Riddle)
<li>only first input cookie recognized (rep by Mattias Nilsson)
<li>jikes now supports -encoding
<li>allow 'host' for http-server.
</ul>

</section>

<section title='1.1.b1 - October 14, 1999'>
<ul>
<li>Servlet Filters, in particular x-application/xtp so Servlet output
can be formatted by XSL
<li>Database pooling rewritten to follow JDBC 2.0 concepts.
<li>The ISAPI filter is fully configurable with resin.conf (rep by Paul Gayeski)
<li>Runtime errors were reported as ServletExceptions
<li>20% performance enhancement to beat Orion
<li>JRun fix on NT (rep by Sergio Soccarras)
<li>TcpServer rewrite to fix synch
<li>getRemoteUser not work on Apache (rep by Luca Bolognese)
<li>request.getRequestDispatcher not properly handling jsp:include (rep by Gita Banga)
<li>mod_caucho array bounds problem
</ul>
</section>

<section title='1.0.1 - October 9, 1999'>
<ul>
<li>XTP -lite generation for HTML generated bogus HEAD section.
<li>Deadlock in Application/VirtualHost
<li>jikes can't handle -encoding (rep by HyoungKi Choi)
<li>POST and jsp:include don't work together (rep by Slawek Zachcial)
<li>IIS goes to 100% under load (rep by Slawek Zachcial)
<li>Class reloading must clear application and session attributes (rep by Hans-Peter Schmidt)
<li>includes need to inherit parameters (rep by HyoungKi Choi)
<li>mod_caucho.c needs to set status on error (fixed by Mattias Nilsson)
<li>precompiled JSP don't need compilation
<li>scripts have bash dependencies
<li>getContentType returns full content-type header (rep by Mattias Nilsson)
<li>JspClassLoader needs to use lookupNative on NT (rep by Rene Biegert)
<li>After 3 days, sessions time out instantly (rep by HyoungKi Choi)
<li>Apache on win32 not properly closing sockets on timeout (rep by Rene Bieger)
<li>nested relative static includes use wrong path (rep by Slawek Zachcial)
<li>class loader problems
<li>/test.jsp/foo/bar compiles different than /test.jsp (rep by Mattias Nilsson)
<li>jsp:useBean class should allow interfaces (rep by Mike Engelhart)
<li>jsp:setProperty not giving error message when interface is missing (rep by Chris Cox)
<li>jsp:setProperty doesn't understand Integer (rep by Chris Cox)
<li>Threading problems with TcpServer
<li>synchronization needed in ClassLoader.loadClass
</ul>
</section>

<section title='1.1.b0 - October 7, 1999'>
<ul>
<li>The bulk of Servlet 2.2 is now available
<li>forms: query, post and include now follow 2.2
<li>Auto-compilation of servlets and beans (see <a href='ref/http-config.xtp'>http-config</a>)
<li>Fixes to Auto-compilation.
<li>Load balancing on Apache (initial impl by Mattias Nilsson)
<li>session cookies disappear across applications (rep by Hans-Peter Schmidt)
</ul>
</section>

<section title='1.0 - September 15, 1999'>
<ul>
<li>Fix for external servlet runners (rep by Leo Deegan)
<li>Reworked TcpServer threading model attempting to avoid JDK accept freeze.
<li>JSP update problem (rep by Emmanuel Blot).
<li>Line # problem with JSP/Java and &lt;% ... %> (rep by Michael Blakeley)
<li>WriteStream array overrun (rep by Emmanuel Blot)
<li>Synch problem with server shutdown
<li>CLASSPATH problems using jikes as java compiler
<li>JRE 1.1 won't start (rep by Cisco Serret)
<li>NT error repoting in directories with blanks
<li>Line # translation in runtime errors
<li>addCookie() wasn't printing expires date correctly (rep by Leo Deegan)
<li>various XSL bugs
<li>xsl.sh now uses strict XSLT by default, XSLT-lite is by -lite.
</ul>
</section>

<section title='b9 - September 3, 1999'>
<ul>
<li>Virtual hosting fixes (rep by HyoungKi Choi)
<li>i18n fixes with forms (rep by Jen Hsien Huang)
<li>srun problems with apache (rep by HyoungKi Choi)
<li>QServlet should be GenericServlet (rep by Vlad Beffa)
<li>stat not picked up in mod_caucho.c (rep by Emmanuel Blot)
<li>sync issues with accept (rep by Michael Blakeley)
<li>JS exception catch bug
<li>JSP isModified now checked periodically instead of each time
<li>WriteStream shutdown when write fails IOException
<li>XSLT-lite uses parsed-content by default to conform with XSLT
</ul>
</section>

<section title='b8 - August 23, 1999'>
<ul>
<li>Virtual hosting fixes (rep by HyoungKi Choi)
<li>JServ support (reported by Andrew Anten and Mark Edwards)
<li>NT Service cleanup with win95
<li>Oracle incompatibilities with ResultSetEcmaWrap (rep by Peter Antman)
<li>Win32 error reporting problems (rep by Neil Bartlett)
<li>Fixed deadlock and increased robustness of connection timeout and server
shutdown (rep by Edgardo Robles)
<li>NT exec problems with directories with spaces (rep by Sebastien Fouss)
<li>Updating class loader didn't find updated WEB-INF/lib/foo.jar (rep by Sebastien Fouss)
<li>i18n fixes for XML, JSP, XSL and POST (rep by CK Chan)
<li>Updates for most recent JSP 1.0 spec
<li>Updates for most recent (Aug) XSL 1.0 spec
</ul>
</section>

<section title='b7 - August 7, 1999'>
<ul>
<li>Quick bug fix for non-Resin servlet engines and language=java
<li>Added template and servlet examples
</ul>
</section>

<section title='b6 - August 6, 1999'>
<ul>
<li>XQL -> XPath following the July draft
<li>XSLT follows the July draft (but see errata)
<li>Resin XSL extensions now use xtp: instead of xsl:, e.g xtp:copy-element
<li>httpd.sh and srun.sh now invoke a perl wrapper responsible for
	  keeping the Java process alive.
<li>start-httpd.sh, stop-httpd.sh, start-srun.sh, and stop-srun.sh added
<li>httpd.exe and srun.exe can now be installed as NT services using
	  -install and -remove
<li>srun_iis.dll no longer needs MFC
<li>split vfs.Stream to ReadStream and WriteStream.
<li>JSP and XTP now have JspManager and XtpManager so servlets can use
	  jsp files and xtp files as templates.
<li>fixed several bugs relating to HTTP/1.1 keepalives
<li>fixed JS wrapping. getNext() was shadowing next()
<li>EUC_KR encoding fixed
<li>JSP contentType now correctly understands charset=foo
<li>Java compilation supports Jikes, allows setting of the tmp directory,
	  and fixes compilation problems with jdk1.1.6
</ul>
</section>

<section title='b5 - July 9, 1999'>

<ul>
<li>Cleaned up the APIs, and exposed JavaDoc
<li>Complete reorganization of the entire codebase
<li>Script invocation overhead drastically reduced.
<li>Supports HTTP/1.1, including virtual hosting
<li>HTTP config now follows Servlet 2.2 API, including WEB-INF
<li>XSLT follows April draft
<li>XSLT-lite cleaned up and formalized
</ul>
</section>

<section title='b4 - June 1, 1999'>

<ul>
<li>Resin now supports JSP 1.0!
<li>Resin now includes servlet runners for Apache and IIS
<li>Java is now a valid, and the default, scripting language.
<li>Supports the JSDK 2.1 clarifications from JSP
<li>Servlet init configuration has changed slightly.
<li>b4 support for other servlet runners is still broken.  Sun's
changes to the JSDK 2.1 api are not available in the other runners
yet, and there hasn't been a chance to add the compatibility.
</ul>

</section>

<section title='b3 - April 28, 1999'>

<ul>
<li>Resin now supports JSDK 2.1
<li>Other servlet runners (JServ, JRun) are not supported by b3.
<li>VFS now supports stderr:, stdout:, and log:.
<li>The mini-httpd is now configurable.
<li>On Windows, Resin finds Java through the Registry.
<li>.application is dead.  applications are configured in resin.conf
</ul>

</section>

<section title='b2 - March 31, 1999'>

<ul>
<li>Renaming *.es -> *.js and *.jtp -> *.atp and request.query->request.form
<li>SCRIPTPATH now looks in RESIN_HOME
<li>Configuration made public (see tutorial, docs will come later :-()
<li>Bug fix for JRun on Windows
<li>Lots of minor bug fixes.
<li>"bug" fix for Kaffe to support HTTP.
<li>Added tutorial and quote.com example
</ul>

</section>

<section title='b1 - March 16, 1999'>

<ul>
<li>Added mailto: and http: to VFS
<li>Performance enhancements
<li>Bug fix to support JRun
<li>Preparation for Java support
</ul>

</section>

<section title='a5 - Feb 28, 1999'>

<ul>
<li>Added JTP, with support for XSL December 1998 Draft
<li>Added simple JTP examples
<li>Added caching for quasi-static pages.
<li>Bug fix for multithreaded mini-HTTP
<li>Bug fix for win32 path lookup.
</ul>

</section>

<section title='a4 - Feb 17, 1999'>

<ul>
<li>Added XQL supporting XSL December 1998 Draft
<li>Navigation Examples
<li>Added multithreading to mini-HTTP
</ul>

</section>

<section title='a3 - Jan 29, 1999'>

<ul>
<li>XML, DOM level 1.0
<li>Major Performance Enhancements
<li>Works with Kaffe interpreter (not compiler)
<li>Bug fixes #271-272,274-285,289,300,304-308
</ul>

</section>

<section title='a2 - Jan 29, 1999'>

<ul>
<li>Bug fixes #263 - 270
<li>Added createRoot, bind, unbind to Path.
<li>Added ScriptClosure to support application events.
</ul>

</section>

<section title='a1 - Dec 30, 1998'>

<ul>
<li>First public release.
<li>ecma-262
<li>netscape 1.3
<li>perl 5 regexp
<li>jsp 0.92
<li>mini-http, exception, classes, import
</ul>

</section>
